# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupsResult',
    'AwaitableGetGroupsResult',
    'get_groups',
    'get_groups_output',
]

@pulumi.output_type
class GetGroupsResult:
    """
    A collection of values returned by getGroups.
    """
    def __init__(__self__, group_id=None, group_lists=None, id=None, name=None, remark=None, result_output_file=None):
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if group_lists and not isinstance(group_lists, list):
            raise TypeError("Expected argument 'group_lists' to be a list")
        pulumi.set(__self__, "group_lists", group_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if remark and not isinstance(remark, str):
            raise TypeError("Expected argument 'remark' to be a str")
        pulumi.set(__self__, "remark", remark)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[str]:
        """
        ID of the CAM group.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="groupLists")
    def group_lists(self) -> Sequence['outputs.GetGroupsGroupListResult']:
        """
        A list of CAM groups. Each element contains the following attributes:
        """
        return pulumi.get(self, "group_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of CAM group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def remark(self) -> Optional[str]:
        """
        Description of CAM group.
        """
        return pulumi.get(self, "remark")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetGroupsResult(GetGroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupsResult(
            group_id=self.group_id,
            group_lists=self.group_lists,
            id=self.id,
            name=self.name,
            remark=self.remark,
            result_output_file=self.result_output_file)


def get_groups(group_id: Optional[str] = None,
               name: Optional[str] = None,
               remark: Optional[str] = None,
               result_output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupsResult:
    """
    Use this data source to query detailed information of CAM groups

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    foo = tencentcloud.Cam.get_groups(group_id=tencentcloud_cam_group["foo"]["id"])
    bar = tencentcloud.Cam.get_groups(name="cam-group-test")
    ```


    :param str group_id: ID of CAM group to be queried.
    :param str name: Name of the CAM group to be queried.
    :param str remark: Description of the cam group to be queried.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    __args__['name'] = name
    __args__['remark'] = remark
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cam/getGroups:getGroups', __args__, opts=opts, typ=GetGroupsResult).value

    return AwaitableGetGroupsResult(
        group_id=__ret__.group_id,
        group_lists=__ret__.group_lists,
        id=__ret__.id,
        name=__ret__.name,
        remark=__ret__.remark,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_groups)
def get_groups_output(group_id: Optional[pulumi.Input[Optional[str]]] = None,
                      name: Optional[pulumi.Input[Optional[str]]] = None,
                      remark: Optional[pulumi.Input[Optional[str]]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGroupsResult]:
    """
    Use this data source to query detailed information of CAM groups

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    foo = tencentcloud.Cam.get_groups(group_id=tencentcloud_cam_group["foo"]["id"])
    bar = tencentcloud.Cam.get_groups(name="cam-group-test")
    ```


    :param str group_id: ID of CAM group to be queried.
    :param str name: Name of the CAM group to be queried.
    :param str remark: Description of the cam group to be queried.
    :param str result_output_file: Used to save results.
    """
    ...
