# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstanceArgs', 'Instance']

@pulumi.input_type
class InstanceArgs:
    def __init__(__self__, *,
                 instance_name: pulumi.Input[str],
                 subnet_id: pulumi.Input[str],
                 vpc_id: pulumi.Input[str],
                 zone_id: pulumi.Input[int],
                 band_width: Optional[pulumi.Input[int]] = None,
                 config: Optional[pulumi.Input['InstanceConfigArgs']] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 disk_type: Optional[pulumi.Input[str]] = None,
                 dynamic_retention_config: Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']] = None,
                 kafka_version: Optional[pulumi.Input[str]] = None,
                 msg_retention_time: Optional[pulumi.Input[int]] = None,
                 multi_zone_flag: Optional[pulumi.Input[bool]] = None,
                 partition: Optional[pulumi.Input[int]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 public_network: Optional[pulumi.Input[int]] = None,
                 rebalance_time: Optional[pulumi.Input[int]] = None,
                 renew_flag: Optional[pulumi.Input[int]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]] = None,
                 zone_ids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        The set of arguments for constructing a Instance resource.
        :param pulumi.Input[str] instance_name: Instance name.
        :param pulumi.Input[str] subnet_id: Subnet id.
        :param pulumi.Input[str] vpc_id: Vpc id.
        :param pulumi.Input[int] zone_id: Available zone id.
        :param pulumi.Input[int] band_width: Instance bandwidth in MBps.
        :param pulumi.Input['InstanceConfigArgs'] config: Instance configuration.
        :param pulumi.Input[int] disk_size: Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[str] disk_type: Type of disk.
        :param pulumi.Input['InstanceDynamicRetentionConfigArgs'] dynamic_retention_config: Dynamic message retention policy configuration.
        :param pulumi.Input[str] kafka_version: Kafka version (0.10.2/1.1.1/2.4.1).
        :param pulumi.Input[int] msg_retention_time: The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        :param pulumi.Input[bool] multi_zone_flag: Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        :param pulumi.Input[int] partition: Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[int] period: Prepaid purchase time, such as 1, is one month.
        :param pulumi.Input[int] public_network: Timestamp.
        :param pulumi.Input[int] rebalance_time: Modification of the rebalancing time after upgrade.
        :param pulumi.Input[int] renew_flag: Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        :param pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]] tags: Partition size, the professional version does not need tag.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] zone_ids: List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        pulumi.set(__self__, "instance_name", instance_name)
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "vpc_id", vpc_id)
        pulumi.set(__self__, "zone_id", zone_id)
        if band_width is not None:
            pulumi.set(__self__, "band_width", band_width)
        if config is not None:
            pulumi.set(__self__, "config", config)
        if disk_size is not None:
            pulumi.set(__self__, "disk_size", disk_size)
        if disk_type is not None:
            pulumi.set(__self__, "disk_type", disk_type)
        if dynamic_retention_config is not None:
            pulumi.set(__self__, "dynamic_retention_config", dynamic_retention_config)
        if kafka_version is not None:
            pulumi.set(__self__, "kafka_version", kafka_version)
        if msg_retention_time is not None:
            pulumi.set(__self__, "msg_retention_time", msg_retention_time)
        if multi_zone_flag is not None:
            pulumi.set(__self__, "multi_zone_flag", multi_zone_flag)
        if partition is not None:
            pulumi.set(__self__, "partition", partition)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if public_network is not None:
            pulumi.set(__self__, "public_network", public_network)
        if rebalance_time is not None:
            pulumi.set(__self__, "rebalance_time", rebalance_time)
        if renew_flag is not None:
            pulumi.set(__self__, "renew_flag", renew_flag)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if zone_ids is not None:
            pulumi.set(__self__, "zone_ids", zone_ids)

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> pulumi.Input[str]:
        """
        Instance name.
        """
        return pulumi.get(self, "instance_name")

    @instance_name.setter
    def instance_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_name", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        Subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Input[str]:
        """
        Vpc id.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[int]:
        """
        Available zone id.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter(name="bandWidth")
    def band_width(self) -> Optional[pulumi.Input[int]]:
        """
        Instance bandwidth in MBps.
        """
        return pulumi.get(self, "band_width")

    @band_width.setter
    def band_width(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "band_width", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input['InstanceConfigArgs']]:
        """
        Instance configuration.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input['InstanceConfigArgs']]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "disk_size")

    @disk_size.setter
    def disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "disk_size", value)

    @property
    @pulumi.getter(name="diskType")
    def disk_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of disk.
        """
        return pulumi.get(self, "disk_type")

    @disk_type.setter
    def disk_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "disk_type", value)

    @property
    @pulumi.getter(name="dynamicRetentionConfig")
    def dynamic_retention_config(self) -> Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']]:
        """
        Dynamic message retention policy configuration.
        """
        return pulumi.get(self, "dynamic_retention_config")

    @dynamic_retention_config.setter
    def dynamic_retention_config(self, value: Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']]):
        pulumi.set(self, "dynamic_retention_config", value)

    @property
    @pulumi.getter(name="kafkaVersion")
    def kafka_version(self) -> Optional[pulumi.Input[str]]:
        """
        Kafka version (0.10.2/1.1.1/2.4.1).
        """
        return pulumi.get(self, "kafka_version")

    @kafka_version.setter
    def kafka_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kafka_version", value)

    @property
    @pulumi.getter(name="msgRetentionTime")
    def msg_retention_time(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        """
        return pulumi.get(self, "msg_retention_time")

    @msg_retention_time.setter
    def msg_retention_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "msg_retention_time", value)

    @property
    @pulumi.getter(name="multiZoneFlag")
    def multi_zone_flag(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        """
        return pulumi.get(self, "multi_zone_flag")

    @multi_zone_flag.setter
    def multi_zone_flag(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "multi_zone_flag", value)

    @property
    @pulumi.getter
    def partition(self) -> Optional[pulumi.Input[int]]:
        """
        Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "partition")

    @partition.setter
    def partition(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "partition", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Prepaid purchase time, such as 1, is one month.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="publicNetwork")
    def public_network(self) -> Optional[pulumi.Input[int]]:
        """
        Timestamp.
        """
        return pulumi.get(self, "public_network")

    @public_network.setter
    def public_network(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "public_network", value)

    @property
    @pulumi.getter(name="rebalanceTime")
    def rebalance_time(self) -> Optional[pulumi.Input[int]]:
        """
        Modification of the rebalancing time after upgrade.
        """
        return pulumi.get(self, "rebalance_time")

    @rebalance_time.setter
    def rebalance_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rebalance_time", value)

    @property
    @pulumi.getter(name="renewFlag")
    def renew_flag(self) -> Optional[pulumi.Input[int]]:
        """
        Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        """
        return pulumi.get(self, "renew_flag")

    @renew_flag.setter
    def renew_flag(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "renew_flag", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]]:
        """
        Partition size, the professional version does not need tag.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="zoneIds")
    def zone_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        return pulumi.get(self, "zone_ids")

    @zone_ids.setter
    def zone_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "zone_ids", value)


@pulumi.input_type
class _InstanceState:
    def __init__(__self__, *,
                 band_width: Optional[pulumi.Input[int]] = None,
                 config: Optional[pulumi.Input['InstanceConfigArgs']] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 disk_type: Optional[pulumi.Input[str]] = None,
                 dynamic_retention_config: Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']] = None,
                 instance_name: Optional[pulumi.Input[str]] = None,
                 kafka_version: Optional[pulumi.Input[str]] = None,
                 msg_retention_time: Optional[pulumi.Input[int]] = None,
                 multi_zone_flag: Optional[pulumi.Input[bool]] = None,
                 partition: Optional[pulumi.Input[int]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 public_network: Optional[pulumi.Input[int]] = None,
                 rebalance_time: Optional[pulumi.Input[int]] = None,
                 renew_flag: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]] = None,
                 vip: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 vport: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[int]] = None,
                 zone_ids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        Input properties used for looking up and filtering Instance resources.
        :param pulumi.Input[int] band_width: Instance bandwidth in MBps.
        :param pulumi.Input['InstanceConfigArgs'] config: Instance configuration.
        :param pulumi.Input[int] disk_size: Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[str] disk_type: Type of disk.
        :param pulumi.Input['InstanceDynamicRetentionConfigArgs'] dynamic_retention_config: Dynamic message retention policy configuration.
        :param pulumi.Input[str] instance_name: Instance name.
        :param pulumi.Input[str] kafka_version: Kafka version (0.10.2/1.1.1/2.4.1).
        :param pulumi.Input[int] msg_retention_time: The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        :param pulumi.Input[bool] multi_zone_flag: Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        :param pulumi.Input[int] partition: Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[int] period: Prepaid purchase time, such as 1, is one month.
        :param pulumi.Input[int] public_network: Timestamp.
        :param pulumi.Input[int] rebalance_time: Modification of the rebalancing time after upgrade.
        :param pulumi.Input[int] renew_flag: Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        :param pulumi.Input[str] subnet_id: Subnet id.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]] tags: Partition size, the professional version does not need tag.
        :param pulumi.Input[str] vip: Vip of instance.
        :param pulumi.Input[str] vpc_id: Vpc id.
        :param pulumi.Input[str] vport: Type of instance.
        :param pulumi.Input[int] zone_id: Available zone id.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] zone_ids: List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        if band_width is not None:
            pulumi.set(__self__, "band_width", band_width)
        if config is not None:
            pulumi.set(__self__, "config", config)
        if disk_size is not None:
            pulumi.set(__self__, "disk_size", disk_size)
        if disk_type is not None:
            pulumi.set(__self__, "disk_type", disk_type)
        if dynamic_retention_config is not None:
            pulumi.set(__self__, "dynamic_retention_config", dynamic_retention_config)
        if instance_name is not None:
            pulumi.set(__self__, "instance_name", instance_name)
        if kafka_version is not None:
            pulumi.set(__self__, "kafka_version", kafka_version)
        if msg_retention_time is not None:
            pulumi.set(__self__, "msg_retention_time", msg_retention_time)
        if multi_zone_flag is not None:
            pulumi.set(__self__, "multi_zone_flag", multi_zone_flag)
        if partition is not None:
            pulumi.set(__self__, "partition", partition)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if public_network is not None:
            pulumi.set(__self__, "public_network", public_network)
        if rebalance_time is not None:
            pulumi.set(__self__, "rebalance_time", rebalance_time)
        if renew_flag is not None:
            pulumi.set(__self__, "renew_flag", renew_flag)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if vip is not None:
            pulumi.set(__self__, "vip", vip)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)
        if vport is not None:
            pulumi.set(__self__, "vport", vport)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)
        if zone_ids is not None:
            pulumi.set(__self__, "zone_ids", zone_ids)

    @property
    @pulumi.getter(name="bandWidth")
    def band_width(self) -> Optional[pulumi.Input[int]]:
        """
        Instance bandwidth in MBps.
        """
        return pulumi.get(self, "band_width")

    @band_width.setter
    def band_width(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "band_width", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input['InstanceConfigArgs']]:
        """
        Instance configuration.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input['InstanceConfigArgs']]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "disk_size")

    @disk_size.setter
    def disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "disk_size", value)

    @property
    @pulumi.getter(name="diskType")
    def disk_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of disk.
        """
        return pulumi.get(self, "disk_type")

    @disk_type.setter
    def disk_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "disk_type", value)

    @property
    @pulumi.getter(name="dynamicRetentionConfig")
    def dynamic_retention_config(self) -> Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']]:
        """
        Dynamic message retention policy configuration.
        """
        return pulumi.get(self, "dynamic_retention_config")

    @dynamic_retention_config.setter
    def dynamic_retention_config(self, value: Optional[pulumi.Input['InstanceDynamicRetentionConfigArgs']]):
        pulumi.set(self, "dynamic_retention_config", value)

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> Optional[pulumi.Input[str]]:
        """
        Instance name.
        """
        return pulumi.get(self, "instance_name")

    @instance_name.setter
    def instance_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_name", value)

    @property
    @pulumi.getter(name="kafkaVersion")
    def kafka_version(self) -> Optional[pulumi.Input[str]]:
        """
        Kafka version (0.10.2/1.1.1/2.4.1).
        """
        return pulumi.get(self, "kafka_version")

    @kafka_version.setter
    def kafka_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kafka_version", value)

    @property
    @pulumi.getter(name="msgRetentionTime")
    def msg_retention_time(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        """
        return pulumi.get(self, "msg_retention_time")

    @msg_retention_time.setter
    def msg_retention_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "msg_retention_time", value)

    @property
    @pulumi.getter(name="multiZoneFlag")
    def multi_zone_flag(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        """
        return pulumi.get(self, "multi_zone_flag")

    @multi_zone_flag.setter
    def multi_zone_flag(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "multi_zone_flag", value)

    @property
    @pulumi.getter
    def partition(self) -> Optional[pulumi.Input[int]]:
        """
        Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "partition")

    @partition.setter
    def partition(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "partition", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Prepaid purchase time, such as 1, is one month.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="publicNetwork")
    def public_network(self) -> Optional[pulumi.Input[int]]:
        """
        Timestamp.
        """
        return pulumi.get(self, "public_network")

    @public_network.setter
    def public_network(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "public_network", value)

    @property
    @pulumi.getter(name="rebalanceTime")
    def rebalance_time(self) -> Optional[pulumi.Input[int]]:
        """
        Modification of the rebalancing time after upgrade.
        """
        return pulumi.get(self, "rebalance_time")

    @rebalance_time.setter
    def rebalance_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rebalance_time", value)

    @property
    @pulumi.getter(name="renewFlag")
    def renew_flag(self) -> Optional[pulumi.Input[int]]:
        """
        Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        """
        return pulumi.get(self, "renew_flag")

    @renew_flag.setter
    def renew_flag(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "renew_flag", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]]:
        """
        Partition size, the professional version does not need tag.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceTagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def vip(self) -> Optional[pulumi.Input[str]]:
        """
        Vip of instance.
        """
        return pulumi.get(self, "vip")

    @vip.setter
    def vip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vip", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        Vpc id.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter
    def vport(self) -> Optional[pulumi.Input[str]]:
        """
        Type of instance.
        """
        return pulumi.get(self, "vport")

    @vport.setter
    def vport(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vport", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[int]]:
        """
        Available zone id.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter(name="zoneIds")
    def zone_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        return pulumi.get(self, "zone_ids")

    @zone_ids.setter
    def zone_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "zone_ids", value)


class Instance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 band_width: Optional[pulumi.Input[int]] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['InstanceConfigArgs']]] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 disk_type: Optional[pulumi.Input[str]] = None,
                 dynamic_retention_config: Optional[pulumi.Input[pulumi.InputType['InstanceDynamicRetentionConfigArgs']]] = None,
                 instance_name: Optional[pulumi.Input[str]] = None,
                 kafka_version: Optional[pulumi.Input[str]] = None,
                 msg_retention_time: Optional[pulumi.Input[int]] = None,
                 multi_zone_flag: Optional[pulumi.Input[bool]] = None,
                 partition: Optional[pulumi.Input[int]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 public_network: Optional[pulumi.Input[int]] = None,
                 rebalance_time: Optional[pulumi.Input[int]] = None,
                 renew_flag: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceTagArgs']]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[int]] = None,
                 zone_ids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 __props__=None):
        """
        Use this resource to create ckafka instance.

        > **NOTE:** It only support create profession ckafka instance.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.ckafka.Instance("foo",
            band_width=40,
            config=tencentcloud.ckafka.InstanceConfigArgs(
                auto_create_topic_enable=True,
                default_num_partitions=3,
                default_replication_factor=3,
            ),
            disk_size=500,
            disk_type="CLOUD_BASIC",
            dynamic_retention_config=tencentcloud.ckafka.InstanceDynamicRetentionConfigArgs(
                bottom_retention=0,
                disk_quota_percentage=0,
                enable=1,
                step_forward_percentage=0,
            ),
            instance_name="ckafka-instance-tf-test",
            kafka_version="1.1.1",
            msg_retention_time=1300,
            multi_zone_flag=True,
            partition=800,
            period=1,
            public_network=3,
            renew_flag=0,
            subnet_id="subnet-4vwihrzk",
            vpc_id="vpc-82p1t1nv",
            zone_id=100006,
            zone_ids=[
                100006,
                100007,
            ])
        ```

        ## Import

        ckafka instance can be imported using the instance_id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ckafka/instance:Instance foo ckafka-f9ife4zz
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] band_width: Instance bandwidth in MBps.
        :param pulumi.Input[pulumi.InputType['InstanceConfigArgs']] config: Instance configuration.
        :param pulumi.Input[int] disk_size: Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[str] disk_type: Type of disk.
        :param pulumi.Input[pulumi.InputType['InstanceDynamicRetentionConfigArgs']] dynamic_retention_config: Dynamic message retention policy configuration.
        :param pulumi.Input[str] instance_name: Instance name.
        :param pulumi.Input[str] kafka_version: Kafka version (0.10.2/1.1.1/2.4.1).
        :param pulumi.Input[int] msg_retention_time: The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        :param pulumi.Input[bool] multi_zone_flag: Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        :param pulumi.Input[int] partition: Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[int] period: Prepaid purchase time, such as 1, is one month.
        :param pulumi.Input[int] public_network: Timestamp.
        :param pulumi.Input[int] rebalance_time: Modification of the rebalancing time after upgrade.
        :param pulumi.Input[int] renew_flag: Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        :param pulumi.Input[str] subnet_id: Subnet id.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceTagArgs']]]] tags: Partition size, the professional version does not need tag.
        :param pulumi.Input[str] vpc_id: Vpc id.
        :param pulumi.Input[int] zone_id: Available zone id.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] zone_ids: List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Use this resource to create ckafka instance.

        > **NOTE:** It only support create profession ckafka instance.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.ckafka.Instance("foo",
            band_width=40,
            config=tencentcloud.ckafka.InstanceConfigArgs(
                auto_create_topic_enable=True,
                default_num_partitions=3,
                default_replication_factor=3,
            ),
            disk_size=500,
            disk_type="CLOUD_BASIC",
            dynamic_retention_config=tencentcloud.ckafka.InstanceDynamicRetentionConfigArgs(
                bottom_retention=0,
                disk_quota_percentage=0,
                enable=1,
                step_forward_percentage=0,
            ),
            instance_name="ckafka-instance-tf-test",
            kafka_version="1.1.1",
            msg_retention_time=1300,
            multi_zone_flag=True,
            partition=800,
            period=1,
            public_network=3,
            renew_flag=0,
            subnet_id="subnet-4vwihrzk",
            vpc_id="vpc-82p1t1nv",
            zone_id=100006,
            zone_ids=[
                100006,
                100007,
            ])
        ```

        ## Import

        ckafka instance can be imported using the instance_id, e.g.

        ```sh
         $ pulumi import tencentcloud:Ckafka/instance:Instance foo ckafka-f9ife4zz
        ```

        :param str resource_name: The name of the resource.
        :param InstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 band_width: Optional[pulumi.Input[int]] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['InstanceConfigArgs']]] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 disk_type: Optional[pulumi.Input[str]] = None,
                 dynamic_retention_config: Optional[pulumi.Input[pulumi.InputType['InstanceDynamicRetentionConfigArgs']]] = None,
                 instance_name: Optional[pulumi.Input[str]] = None,
                 kafka_version: Optional[pulumi.Input[str]] = None,
                 msg_retention_time: Optional[pulumi.Input[int]] = None,
                 multi_zone_flag: Optional[pulumi.Input[bool]] = None,
                 partition: Optional[pulumi.Input[int]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 public_network: Optional[pulumi.Input[int]] = None,
                 rebalance_time: Optional[pulumi.Input[int]] = None,
                 renew_flag: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceTagArgs']]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[int]] = None,
                 zone_ids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceArgs.__new__(InstanceArgs)

            __props__.__dict__["band_width"] = band_width
            __props__.__dict__["config"] = config
            __props__.__dict__["disk_size"] = disk_size
            __props__.__dict__["disk_type"] = disk_type
            __props__.__dict__["dynamic_retention_config"] = dynamic_retention_config
            if instance_name is None and not opts.urn:
                raise TypeError("Missing required property 'instance_name'")
            __props__.__dict__["instance_name"] = instance_name
            __props__.__dict__["kafka_version"] = kafka_version
            __props__.__dict__["msg_retention_time"] = msg_retention_time
            __props__.__dict__["multi_zone_flag"] = multi_zone_flag
            __props__.__dict__["partition"] = partition
            __props__.__dict__["period"] = period
            __props__.__dict__["public_network"] = public_network
            __props__.__dict__["rebalance_time"] = rebalance_time
            __props__.__dict__["renew_flag"] = renew_flag
            if subnet_id is None and not opts.urn:
                raise TypeError("Missing required property 'subnet_id'")
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["tags"] = tags
            if vpc_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_id'")
            __props__.__dict__["vpc_id"] = vpc_id
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
            __props__.__dict__["zone_ids"] = zone_ids
            __props__.__dict__["vip"] = None
            __props__.__dict__["vport"] = None
        super(Instance, __self__).__init__(
            'tencentcloud:Ckafka/instance:Instance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            band_width: Optional[pulumi.Input[int]] = None,
            config: Optional[pulumi.Input[pulumi.InputType['InstanceConfigArgs']]] = None,
            disk_size: Optional[pulumi.Input[int]] = None,
            disk_type: Optional[pulumi.Input[str]] = None,
            dynamic_retention_config: Optional[pulumi.Input[pulumi.InputType['InstanceDynamicRetentionConfigArgs']]] = None,
            instance_name: Optional[pulumi.Input[str]] = None,
            kafka_version: Optional[pulumi.Input[str]] = None,
            msg_retention_time: Optional[pulumi.Input[int]] = None,
            multi_zone_flag: Optional[pulumi.Input[bool]] = None,
            partition: Optional[pulumi.Input[int]] = None,
            period: Optional[pulumi.Input[int]] = None,
            public_network: Optional[pulumi.Input[int]] = None,
            rebalance_time: Optional[pulumi.Input[int]] = None,
            renew_flag: Optional[pulumi.Input[int]] = None,
            subnet_id: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceTagArgs']]]]] = None,
            vip: Optional[pulumi.Input[str]] = None,
            vpc_id: Optional[pulumi.Input[str]] = None,
            vport: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[int]] = None,
            zone_ids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None) -> 'Instance':
        """
        Get an existing Instance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] band_width: Instance bandwidth in MBps.
        :param pulumi.Input[pulumi.InputType['InstanceConfigArgs']] config: Instance configuration.
        :param pulumi.Input[int] disk_size: Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[str] disk_type: Type of disk.
        :param pulumi.Input[pulumi.InputType['InstanceDynamicRetentionConfigArgs']] dynamic_retention_config: Dynamic message retention policy configuration.
        :param pulumi.Input[str] instance_name: Instance name.
        :param pulumi.Input[str] kafka_version: Kafka version (0.10.2/1.1.1/2.4.1).
        :param pulumi.Input[int] msg_retention_time: The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        :param pulumi.Input[bool] multi_zone_flag: Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        :param pulumi.Input[int] partition: Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        :param pulumi.Input[int] period: Prepaid purchase time, such as 1, is one month.
        :param pulumi.Input[int] public_network: Timestamp.
        :param pulumi.Input[int] rebalance_time: Modification of the rebalancing time after upgrade.
        :param pulumi.Input[int] renew_flag: Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        :param pulumi.Input[str] subnet_id: Subnet id.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceTagArgs']]]] tags: Partition size, the professional version does not need tag.
        :param pulumi.Input[str] vip: Vip of instance.
        :param pulumi.Input[str] vpc_id: Vpc id.
        :param pulumi.Input[str] vport: Type of instance.
        :param pulumi.Input[int] zone_id: Available zone id.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] zone_ids: List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceState.__new__(_InstanceState)

        __props__.__dict__["band_width"] = band_width
        __props__.__dict__["config"] = config
        __props__.__dict__["disk_size"] = disk_size
        __props__.__dict__["disk_type"] = disk_type
        __props__.__dict__["dynamic_retention_config"] = dynamic_retention_config
        __props__.__dict__["instance_name"] = instance_name
        __props__.__dict__["kafka_version"] = kafka_version
        __props__.__dict__["msg_retention_time"] = msg_retention_time
        __props__.__dict__["multi_zone_flag"] = multi_zone_flag
        __props__.__dict__["partition"] = partition
        __props__.__dict__["period"] = period
        __props__.__dict__["public_network"] = public_network
        __props__.__dict__["rebalance_time"] = rebalance_time
        __props__.__dict__["renew_flag"] = renew_flag
        __props__.__dict__["subnet_id"] = subnet_id
        __props__.__dict__["tags"] = tags
        __props__.__dict__["vip"] = vip
        __props__.__dict__["vpc_id"] = vpc_id
        __props__.__dict__["vport"] = vport
        __props__.__dict__["zone_id"] = zone_id
        __props__.__dict__["zone_ids"] = zone_ids
        return Instance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="bandWidth")
    def band_width(self) -> pulumi.Output[int]:
        """
        Instance bandwidth in MBps.
        """
        return pulumi.get(self, "band_width")

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output[Optional['outputs.InstanceConfig']]:
        """
        Instance configuration.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> pulumi.Output[int]:
        """
        Disk Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "disk_size")

    @property
    @pulumi.getter(name="diskType")
    def disk_type(self) -> pulumi.Output[str]:
        """
        Type of disk.
        """
        return pulumi.get(self, "disk_type")

    @property
    @pulumi.getter(name="dynamicRetentionConfig")
    def dynamic_retention_config(self) -> pulumi.Output['outputs.InstanceDynamicRetentionConfig']:
        """
        Dynamic message retention policy configuration.
        """
        return pulumi.get(self, "dynamic_retention_config")

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> pulumi.Output[str]:
        """
        Instance name.
        """
        return pulumi.get(self, "instance_name")

    @property
    @pulumi.getter(name="kafkaVersion")
    def kafka_version(self) -> pulumi.Output[str]:
        """
        Kafka version (0.10.2/1.1.1/2.4.1).
        """
        return pulumi.get(self, "kafka_version")

    @property
    @pulumi.getter(name="msgRetentionTime")
    def msg_retention_time(self) -> pulumi.Output[int]:
        """
        The maximum retention time of instance logs, in minutes. the default is 10080 (7 days), the maximum is 30 days, and the default 0 is not filled, which means that the log retention time recovery policy is not enabled.
        """
        return pulumi.get(self, "msg_retention_time")

    @property
    @pulumi.getter(name="multiZoneFlag")
    def multi_zone_flag(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether the instance is multi zones. NOTE: if set to `true`, `zone_ids` must set together.
        """
        return pulumi.get(self, "multi_zone_flag")

    @property
    @pulumi.getter
    def partition(self) -> pulumi.Output[int]:
        """
        Partition Size. Its interval varies with bandwidth, and the input must be within the interval, which can be viewed through the control. If it is not within the interval, the plan will cause a change when first created.
        """
        return pulumi.get(self, "partition")

    @property
    @pulumi.getter
    def period(self) -> pulumi.Output[Optional[int]]:
        """
        Prepaid purchase time, such as 1, is one month.
        """
        return pulumi.get(self, "period")

    @property
    @pulumi.getter(name="publicNetwork")
    def public_network(self) -> pulumi.Output[int]:
        """
        Timestamp.
        """
        return pulumi.get(self, "public_network")

    @property
    @pulumi.getter(name="rebalanceTime")
    def rebalance_time(self) -> pulumi.Output[Optional[int]]:
        """
        Modification of the rebalancing time after upgrade.
        """
        return pulumi.get(self, "rebalance_time")

    @property
    @pulumi.getter(name="renewFlag")
    def renew_flag(self) -> pulumi.Output[int]:
        """
        Prepaid automatic renewal mark, 0 means the default state, the initial state, 1 means automatic renewal, 2 means clear no automatic renewal (user setting).
        """
        return pulumi.get(self, "renew_flag")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[str]:
        """
        Subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['outputs.InstanceTag']]]:
        """
        Partition size, the professional version does not need tag.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def vip(self) -> pulumi.Output[str]:
        """
        Vip of instance.
        """
        return pulumi.get(self, "vip")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[str]:
        """
        Vpc id.
        """
        return pulumi.get(self, "vpc_id")

    @property
    @pulumi.getter
    def vport(self) -> pulumi.Output[str]:
        """
        Type of instance.
        """
        return pulumi.get(self, "vport")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[int]:
        """
        Available zone id.
        """
        return pulumi.get(self, "zone_id")

    @property
    @pulumi.getter(name="zoneIds")
    def zone_ids(self) -> pulumi.Output[Optional[Sequence[int]]]:
        """
        List of available zone id. NOTE: this argument must set together with `multi_zone_flag`.
        """
        return pulumi.get(self, "zone_ids")

