# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstanceArgs', 'Instance']

@pulumi.input_type
class InstanceArgs:
    def __init__(__self__, *,
                 clb_name: pulumi.Input[str],
                 network_type: pulumi.Input[str],
                 address_ip_version: Optional[pulumi.Input[str]] = None,
                 bandwidth_package_id: Optional[pulumi.Input[str]] = None,
                 internet_bandwidth_max_out: Optional[pulumi.Input[int]] = None,
                 internet_charge_type: Optional[pulumi.Input[str]] = None,
                 load_balancer_pass_to_target: Optional[pulumi.Input[bool]] = None,
                 log_set_id: Optional[pulumi.Input[str]] = None,
                 log_topic_id: Optional[pulumi.Input[str]] = None,
                 master_zone_id: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 slave_zone_id: Optional[pulumi.Input[str]] = None,
                 snat_ips: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]] = None,
                 snat_pro: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 target_region_info_region: Optional[pulumi.Input[str]] = None,
                 target_region_info_vpc_id: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Instance resource.
        :param pulumi.Input[str] clb_name: Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        :param pulumi.Input[str] network_type: Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        :param pulumi.Input[str] address_ip_version: IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        :param pulumi.Input[str] bandwidth_package_id: Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[int] internet_bandwidth_max_out: Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        :param pulumi.Input[str] internet_charge_type: Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[bool] load_balancer_pass_to_target: Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        :param pulumi.Input[str] log_set_id: The id of log set.
        :param pulumi.Input[str] log_topic_id: The id of log topic.
        :param pulumi.Input[str] master_zone_id: Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        :param pulumi.Input[int] project_id: ID of the project within the CLB instance, `0` - Default Project.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        :param pulumi.Input[str] slave_zone_id: Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]] snat_ips: Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        :param pulumi.Input[bool] snat_pro: Indicates whether Binding IPs of other VPCs feature switch.
        :param pulumi.Input[str] subnet_id: Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        :param pulumi.Input[Mapping[str, Any]] tags: The available tags within this CLB.
        :param pulumi.Input[str] target_region_info_region: Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] target_region_info_vpc_id: Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] vpc_id: VPC ID of the CLB.
        :param pulumi.Input[str] zone_id: Available zone id, only applicable to open CLB.
        """
        pulumi.set(__self__, "clb_name", clb_name)
        pulumi.set(__self__, "network_type", network_type)
        if address_ip_version is not None:
            pulumi.set(__self__, "address_ip_version", address_ip_version)
        if bandwidth_package_id is not None:
            pulumi.set(__self__, "bandwidth_package_id", bandwidth_package_id)
        if internet_bandwidth_max_out is not None:
            pulumi.set(__self__, "internet_bandwidth_max_out", internet_bandwidth_max_out)
        if internet_charge_type is not None:
            pulumi.set(__self__, "internet_charge_type", internet_charge_type)
        if load_balancer_pass_to_target is not None:
            pulumi.set(__self__, "load_balancer_pass_to_target", load_balancer_pass_to_target)
        if log_set_id is not None:
            pulumi.set(__self__, "log_set_id", log_set_id)
        if log_topic_id is not None:
            pulumi.set(__self__, "log_topic_id", log_topic_id)
        if master_zone_id is not None:
            pulumi.set(__self__, "master_zone_id", master_zone_id)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if slave_zone_id is not None:
            pulumi.set(__self__, "slave_zone_id", slave_zone_id)
        if snat_ips is not None:
            pulumi.set(__self__, "snat_ips", snat_ips)
        if snat_pro is not None:
            pulumi.set(__self__, "snat_pro", snat_pro)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if target_region_info_region is not None:
            pulumi.set(__self__, "target_region_info_region", target_region_info_region)
        if target_region_info_vpc_id is not None:
            pulumi.set(__self__, "target_region_info_vpc_id", target_region_info_vpc_id)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="clbName")
    def clb_name(self) -> pulumi.Input[str]:
        """
        Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        """
        return pulumi.get(self, "clb_name")

    @clb_name.setter
    def clb_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "clb_name", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> pulumi.Input[str]:
        """
        Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter(name="addressIpVersion")
    def address_ip_version(self) -> Optional[pulumi.Input[str]]:
        """
        IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        """
        return pulumi.get(self, "address_ip_version")

    @address_ip_version.setter
    def address_ip_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_ip_version", value)

    @property
    @pulumi.getter(name="bandwidthPackageId")
    def bandwidth_package_id(self) -> Optional[pulumi.Input[str]]:
        """
        Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "bandwidth_package_id")

    @bandwidth_package_id.setter
    def bandwidth_package_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bandwidth_package_id", value)

    @property
    @pulumi.getter(name="internetBandwidthMaxOut")
    def internet_bandwidth_max_out(self) -> Optional[pulumi.Input[int]]:
        """
        Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        """
        return pulumi.get(self, "internet_bandwidth_max_out")

    @internet_bandwidth_max_out.setter
    def internet_bandwidth_max_out(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "internet_bandwidth_max_out", value)

    @property
    @pulumi.getter(name="internetChargeType")
    def internet_charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "internet_charge_type")

    @internet_charge_type.setter
    def internet_charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "internet_charge_type", value)

    @property
    @pulumi.getter(name="loadBalancerPassToTarget")
    def load_balancer_pass_to_target(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        """
        return pulumi.get(self, "load_balancer_pass_to_target")

    @load_balancer_pass_to_target.setter
    def load_balancer_pass_to_target(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "load_balancer_pass_to_target", value)

    @property
    @pulumi.getter(name="logSetId")
    def log_set_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of log set.
        """
        return pulumi.get(self, "log_set_id")

    @log_set_id.setter
    def log_set_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_set_id", value)

    @property
    @pulumi.getter(name="logTopicId")
    def log_topic_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of log topic.
        """
        return pulumi.get(self, "log_topic_id")

    @log_topic_id.setter
    def log_topic_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_topic_id", value)

    @property
    @pulumi.getter(name="masterZoneId")
    def master_zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        """
        return pulumi.get(self, "master_zone_id")

    @master_zone_id.setter
    def master_zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "master_zone_id", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[int]]:
        """
        ID of the project within the CLB instance, `0` - Default Project.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter(name="slaveZoneId")
    def slave_zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        """
        return pulumi.get(self, "slave_zone_id")

    @slave_zone_id.setter
    def slave_zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "slave_zone_id", value)

    @property
    @pulumi.getter(name="snatIps")
    def snat_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]]:
        """
        Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        """
        return pulumi.get(self, "snat_ips")

    @snat_ips.setter
    def snat_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]]):
        pulumi.set(self, "snat_ips", value)

    @property
    @pulumi.getter(name="snatPro")
    def snat_pro(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Binding IPs of other VPCs feature switch.
        """
        return pulumi.get(self, "snat_pro")

    @snat_pro.setter
    def snat_pro(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "snat_pro", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        The available tags within this CLB.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="targetRegionInfoRegion")
    def target_region_info_region(self) -> Optional[pulumi.Input[str]]:
        """
        Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_region")

    @target_region_info_region.setter
    def target_region_info_region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_region_info_region", value)

    @property
    @pulumi.getter(name="targetRegionInfoVpcId")
    def target_region_info_vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_vpc_id")

    @target_region_info_vpc_id.setter
    def target_region_info_vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_region_info_vpc_id", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        VPC ID of the CLB.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Available zone id, only applicable to open CLB.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


@pulumi.input_type
class _InstanceState:
    def __init__(__self__, *,
                 address_ip_version: Optional[pulumi.Input[str]] = None,
                 bandwidth_package_id: Optional[pulumi.Input[str]] = None,
                 clb_name: Optional[pulumi.Input[str]] = None,
                 clb_vips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 internet_bandwidth_max_out: Optional[pulumi.Input[int]] = None,
                 internet_charge_type: Optional[pulumi.Input[str]] = None,
                 load_balancer_pass_to_target: Optional[pulumi.Input[bool]] = None,
                 log_set_id: Optional[pulumi.Input[str]] = None,
                 log_topic_id: Optional[pulumi.Input[str]] = None,
                 master_zone_id: Optional[pulumi.Input[str]] = None,
                 network_type: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 slave_zone_id: Optional[pulumi.Input[str]] = None,
                 snat_ips: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]] = None,
                 snat_pro: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 target_region_info_region: Optional[pulumi.Input[str]] = None,
                 target_region_info_vpc_id: Optional[pulumi.Input[str]] = None,
                 vip_isp: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Instance resources.
        :param pulumi.Input[str] address_ip_version: IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        :param pulumi.Input[str] bandwidth_package_id: Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[str] clb_name: Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] clb_vips: The virtual service address table of the CLB.
        :param pulumi.Input[int] internet_bandwidth_max_out: Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        :param pulumi.Input[str] internet_charge_type: Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[bool] load_balancer_pass_to_target: Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        :param pulumi.Input[str] log_set_id: The id of log set.
        :param pulumi.Input[str] log_topic_id: The id of log topic.
        :param pulumi.Input[str] master_zone_id: Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        :param pulumi.Input[str] network_type: Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        :param pulumi.Input[int] project_id: ID of the project within the CLB instance, `0` - Default Project.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        :param pulumi.Input[str] slave_zone_id: Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]] snat_ips: Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        :param pulumi.Input[bool] snat_pro: Indicates whether Binding IPs of other VPCs feature switch.
        :param pulumi.Input[str] subnet_id: Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        :param pulumi.Input[Mapping[str, Any]] tags: The available tags within this CLB.
        :param pulumi.Input[str] target_region_info_region: Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] target_region_info_vpc_id: Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] vip_isp: Network operator, only applicable to open CLB. Valid values are `CMCC`(China Mobile), `CTCC`(Telecom), `CUCC`(China Unicom) and `BGP`. If this ISP is specified, network billing method can only use the bandwidth package billing (BANDWIDTH_PACKAGE).
        :param pulumi.Input[str] vpc_id: VPC ID of the CLB.
        :param pulumi.Input[str] zone_id: Available zone id, only applicable to open CLB.
        """
        if address_ip_version is not None:
            pulumi.set(__self__, "address_ip_version", address_ip_version)
        if bandwidth_package_id is not None:
            pulumi.set(__self__, "bandwidth_package_id", bandwidth_package_id)
        if clb_name is not None:
            pulumi.set(__self__, "clb_name", clb_name)
        if clb_vips is not None:
            pulumi.set(__self__, "clb_vips", clb_vips)
        if internet_bandwidth_max_out is not None:
            pulumi.set(__self__, "internet_bandwidth_max_out", internet_bandwidth_max_out)
        if internet_charge_type is not None:
            pulumi.set(__self__, "internet_charge_type", internet_charge_type)
        if load_balancer_pass_to_target is not None:
            pulumi.set(__self__, "load_balancer_pass_to_target", load_balancer_pass_to_target)
        if log_set_id is not None:
            pulumi.set(__self__, "log_set_id", log_set_id)
        if log_topic_id is not None:
            pulumi.set(__self__, "log_topic_id", log_topic_id)
        if master_zone_id is not None:
            pulumi.set(__self__, "master_zone_id", master_zone_id)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if slave_zone_id is not None:
            pulumi.set(__self__, "slave_zone_id", slave_zone_id)
        if snat_ips is not None:
            pulumi.set(__self__, "snat_ips", snat_ips)
        if snat_pro is not None:
            pulumi.set(__self__, "snat_pro", snat_pro)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if target_region_info_region is not None:
            pulumi.set(__self__, "target_region_info_region", target_region_info_region)
        if target_region_info_vpc_id is not None:
            pulumi.set(__self__, "target_region_info_vpc_id", target_region_info_vpc_id)
        if vip_isp is not None:
            pulumi.set(__self__, "vip_isp", vip_isp)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="addressIpVersion")
    def address_ip_version(self) -> Optional[pulumi.Input[str]]:
        """
        IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        """
        return pulumi.get(self, "address_ip_version")

    @address_ip_version.setter
    def address_ip_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_ip_version", value)

    @property
    @pulumi.getter(name="bandwidthPackageId")
    def bandwidth_package_id(self) -> Optional[pulumi.Input[str]]:
        """
        Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "bandwidth_package_id")

    @bandwidth_package_id.setter
    def bandwidth_package_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bandwidth_package_id", value)

    @property
    @pulumi.getter(name="clbName")
    def clb_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        """
        return pulumi.get(self, "clb_name")

    @clb_name.setter
    def clb_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "clb_name", value)

    @property
    @pulumi.getter(name="clbVips")
    def clb_vips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The virtual service address table of the CLB.
        """
        return pulumi.get(self, "clb_vips")

    @clb_vips.setter
    def clb_vips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "clb_vips", value)

    @property
    @pulumi.getter(name="internetBandwidthMaxOut")
    def internet_bandwidth_max_out(self) -> Optional[pulumi.Input[int]]:
        """
        Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        """
        return pulumi.get(self, "internet_bandwidth_max_out")

    @internet_bandwidth_max_out.setter
    def internet_bandwidth_max_out(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "internet_bandwidth_max_out", value)

    @property
    @pulumi.getter(name="internetChargeType")
    def internet_charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "internet_charge_type")

    @internet_charge_type.setter
    def internet_charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "internet_charge_type", value)

    @property
    @pulumi.getter(name="loadBalancerPassToTarget")
    def load_balancer_pass_to_target(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        """
        return pulumi.get(self, "load_balancer_pass_to_target")

    @load_balancer_pass_to_target.setter
    def load_balancer_pass_to_target(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "load_balancer_pass_to_target", value)

    @property
    @pulumi.getter(name="logSetId")
    def log_set_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of log set.
        """
        return pulumi.get(self, "log_set_id")

    @log_set_id.setter
    def log_set_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_set_id", value)

    @property
    @pulumi.getter(name="logTopicId")
    def log_topic_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of log topic.
        """
        return pulumi.get(self, "log_topic_id")

    @log_topic_id.setter
    def log_topic_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_topic_id", value)

    @property
    @pulumi.getter(name="masterZoneId")
    def master_zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        """
        return pulumi.get(self, "master_zone_id")

    @master_zone_id.setter
    def master_zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "master_zone_id", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[int]]:
        """
        ID of the project within the CLB instance, `0` - Default Project.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter(name="slaveZoneId")
    def slave_zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        """
        return pulumi.get(self, "slave_zone_id")

    @slave_zone_id.setter
    def slave_zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "slave_zone_id", value)

    @property
    @pulumi.getter(name="snatIps")
    def snat_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]]:
        """
        Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        """
        return pulumi.get(self, "snat_ips")

    @snat_ips.setter
    def snat_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSnatIpArgs']]]]):
        pulumi.set(self, "snat_ips", value)

    @property
    @pulumi.getter(name="snatPro")
    def snat_pro(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Binding IPs of other VPCs feature switch.
        """
        return pulumi.get(self, "snat_pro")

    @snat_pro.setter
    def snat_pro(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "snat_pro", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        The available tags within this CLB.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="targetRegionInfoRegion")
    def target_region_info_region(self) -> Optional[pulumi.Input[str]]:
        """
        Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_region")

    @target_region_info_region.setter
    def target_region_info_region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_region_info_region", value)

    @property
    @pulumi.getter(name="targetRegionInfoVpcId")
    def target_region_info_vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_vpc_id")

    @target_region_info_vpc_id.setter
    def target_region_info_vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_region_info_vpc_id", value)

    @property
    @pulumi.getter(name="vipIsp")
    def vip_isp(self) -> Optional[pulumi.Input[str]]:
        """
        Network operator, only applicable to open CLB. Valid values are `CMCC`(China Mobile), `CTCC`(Telecom), `CUCC`(China Unicom) and `BGP`. If this ISP is specified, network billing method can only use the bandwidth package billing (BANDWIDTH_PACKAGE).
        """
        return pulumi.get(self, "vip_isp")

    @vip_isp.setter
    def vip_isp(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vip_isp", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        VPC ID of the CLB.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Available zone id, only applicable to open CLB.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class Instance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_ip_version: Optional[pulumi.Input[str]] = None,
                 bandwidth_package_id: Optional[pulumi.Input[str]] = None,
                 clb_name: Optional[pulumi.Input[str]] = None,
                 internet_bandwidth_max_out: Optional[pulumi.Input[int]] = None,
                 internet_charge_type: Optional[pulumi.Input[str]] = None,
                 load_balancer_pass_to_target: Optional[pulumi.Input[bool]] = None,
                 log_set_id: Optional[pulumi.Input[str]] = None,
                 log_topic_id: Optional[pulumi.Input[str]] = None,
                 master_zone_id: Optional[pulumi.Input[str]] = None,
                 network_type: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 slave_zone_id: Optional[pulumi.Input[str]] = None,
                 snat_ips: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSnatIpArgs']]]]] = None,
                 snat_pro: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 target_region_info_region: Optional[pulumi.Input[str]] = None,
                 target_region_info_vpc_id: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a CLB instance.

        ## Example Usage

        INTERNAL CLB

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        internal_clb = tencentcloud.clb.Instance("internalClb",
            clb_name="myclb",
            network_type="INTERNAL",
            project_id=0,
            subnet_id="subnet-12rastkr",
            tags={
                "test": "tf",
            },
            vpc_id="vpc-7007ll7q")
        ```

        OPEN CLB

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        open_clb = tencentcloud.clb.Instance("openClb",
            clb_name="myclb",
            network_type="OPEN",
            project_id=0,
            security_groups=["sg-o0ek7r93"],
            tags={
                "test": "tf",
            },
            target_region_info_region="ap-guangzhou",
            target_region_info_vpc_id="vpc-da7ffa61",
            vpc_id="vpc-da7ffa61")
        ```

        Default enable

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.vpc.Instance("foo",
            cidr_block="10.0.0.0/16",
            tags={
                "test": "mytest",
            })
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone="ap-guangzhou-1",
            vpc_id=foo.id,
            cidr_block="10.0.20.0/28",
            is_multicast=False)
        sglab = tencentcloud.security.Group("sglab",
            description="favourite sg",
            project_id=0)
        open_clb = tencentcloud.clb.Instance("openClb",
            network_type="OPEN",
            clb_name="my-open-clb",
            project_id=0,
            vpc_id=foo.id,
            load_balancer_pass_to_target=True,
            security_groups=[sglab.id],
            target_region_info_region="ap-guangzhou",
            target_region_info_vpc_id=foo.id,
            tags={
                "test": "open",
            })
        ```

        CREATE multiple instance

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        open_clb1 = tencentcloud.clb.Instance("openClb1",
            clb_name="hello",
            master_zone_id="ap-guangzhou-3",
            network_type="OPEN")
        ```

        CREATE instance with log

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        vpc_test = tencentcloud.vpc.Instance("vpcTest", cidr_block="10.0.0.0/16")
        rtb_test = tencentcloud.route.Table("rtbTest", vpc_id=vpc_test.id)
        subnet_test = tencentcloud.subnet.Instance("subnetTest",
            availability_zone="ap-guangzhou-3",
            cidr_block="10.0.1.0/24",
            route_table_id=rtb_test.id,
            vpc_id=vpc_test.id)
        set = tencentcloud.clb.LogSet("set", period=7)
        topic = tencentcloud.clb.LogTopic("topic",
            log_set_id=set.id,
            topic_name="clb-topic")
        internal_clb = tencentcloud.clb.Instance("internalClb",
            clb_name="myclb",
            load_balancer_pass_to_target=True,
            log_set_id=set.id,
            log_topic_id=topic.id,
            network_type="INTERNAL",
            project_id=0,
            subnet_id=subnet_test.id,
            tags={
                "test": "tf",
            },
            vpc_id=vpc_test.id)
        ```

        ## Import

        CLB instance can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Clb/instance:Instance foo lb-7a0t6zqb
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_ip_version: IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        :param pulumi.Input[str] bandwidth_package_id: Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[str] clb_name: Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        :param pulumi.Input[int] internet_bandwidth_max_out: Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        :param pulumi.Input[str] internet_charge_type: Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[bool] load_balancer_pass_to_target: Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        :param pulumi.Input[str] log_set_id: The id of log set.
        :param pulumi.Input[str] log_topic_id: The id of log topic.
        :param pulumi.Input[str] master_zone_id: Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        :param pulumi.Input[str] network_type: Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        :param pulumi.Input[int] project_id: ID of the project within the CLB instance, `0` - Default Project.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        :param pulumi.Input[str] slave_zone_id: Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSnatIpArgs']]]] snat_ips: Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        :param pulumi.Input[bool] snat_pro: Indicates whether Binding IPs of other VPCs feature switch.
        :param pulumi.Input[str] subnet_id: Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        :param pulumi.Input[Mapping[str, Any]] tags: The available tags within this CLB.
        :param pulumi.Input[str] target_region_info_region: Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] target_region_info_vpc_id: Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] vpc_id: VPC ID of the CLB.
        :param pulumi.Input[str] zone_id: Available zone id, only applicable to open CLB.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a CLB instance.

        ## Example Usage

        INTERNAL CLB

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        internal_clb = tencentcloud.clb.Instance("internalClb",
            clb_name="myclb",
            network_type="INTERNAL",
            project_id=0,
            subnet_id="subnet-12rastkr",
            tags={
                "test": "tf",
            },
            vpc_id="vpc-7007ll7q")
        ```

        OPEN CLB

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        open_clb = tencentcloud.clb.Instance("openClb",
            clb_name="myclb",
            network_type="OPEN",
            project_id=0,
            security_groups=["sg-o0ek7r93"],
            tags={
                "test": "tf",
            },
            target_region_info_region="ap-guangzhou",
            target_region_info_vpc_id="vpc-da7ffa61",
            vpc_id="vpc-da7ffa61")
        ```

        Default enable

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.vpc.Instance("foo",
            cidr_block="10.0.0.0/16",
            tags={
                "test": "mytest",
            })
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone="ap-guangzhou-1",
            vpc_id=foo.id,
            cidr_block="10.0.20.0/28",
            is_multicast=False)
        sglab = tencentcloud.security.Group("sglab",
            description="favourite sg",
            project_id=0)
        open_clb = tencentcloud.clb.Instance("openClb",
            network_type="OPEN",
            clb_name="my-open-clb",
            project_id=0,
            vpc_id=foo.id,
            load_balancer_pass_to_target=True,
            security_groups=[sglab.id],
            target_region_info_region="ap-guangzhou",
            target_region_info_vpc_id=foo.id,
            tags={
                "test": "open",
            })
        ```

        CREATE multiple instance

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        open_clb1 = tencentcloud.clb.Instance("openClb1",
            clb_name="hello",
            master_zone_id="ap-guangzhou-3",
            network_type="OPEN")
        ```

        CREATE instance with log

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        vpc_test = tencentcloud.vpc.Instance("vpcTest", cidr_block="10.0.0.0/16")
        rtb_test = tencentcloud.route.Table("rtbTest", vpc_id=vpc_test.id)
        subnet_test = tencentcloud.subnet.Instance("subnetTest",
            availability_zone="ap-guangzhou-3",
            cidr_block="10.0.1.0/24",
            route_table_id=rtb_test.id,
            vpc_id=vpc_test.id)
        set = tencentcloud.clb.LogSet("set", period=7)
        topic = tencentcloud.clb.LogTopic("topic",
            log_set_id=set.id,
            topic_name="clb-topic")
        internal_clb = tencentcloud.clb.Instance("internalClb",
            clb_name="myclb",
            load_balancer_pass_to_target=True,
            log_set_id=set.id,
            log_topic_id=topic.id,
            network_type="INTERNAL",
            project_id=0,
            subnet_id=subnet_test.id,
            tags={
                "test": "tf",
            },
            vpc_id=vpc_test.id)
        ```

        ## Import

        CLB instance can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Clb/instance:Instance foo lb-7a0t6zqb
        ```

        :param str resource_name: The name of the resource.
        :param InstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_ip_version: Optional[pulumi.Input[str]] = None,
                 bandwidth_package_id: Optional[pulumi.Input[str]] = None,
                 clb_name: Optional[pulumi.Input[str]] = None,
                 internet_bandwidth_max_out: Optional[pulumi.Input[int]] = None,
                 internet_charge_type: Optional[pulumi.Input[str]] = None,
                 load_balancer_pass_to_target: Optional[pulumi.Input[bool]] = None,
                 log_set_id: Optional[pulumi.Input[str]] = None,
                 log_topic_id: Optional[pulumi.Input[str]] = None,
                 master_zone_id: Optional[pulumi.Input[str]] = None,
                 network_type: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 slave_zone_id: Optional[pulumi.Input[str]] = None,
                 snat_ips: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSnatIpArgs']]]]] = None,
                 snat_pro: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 target_region_info_region: Optional[pulumi.Input[str]] = None,
                 target_region_info_vpc_id: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceArgs.__new__(InstanceArgs)

            __props__.__dict__["address_ip_version"] = address_ip_version
            __props__.__dict__["bandwidth_package_id"] = bandwidth_package_id
            if clb_name is None and not opts.urn:
                raise TypeError("Missing required property 'clb_name'")
            __props__.__dict__["clb_name"] = clb_name
            __props__.__dict__["internet_bandwidth_max_out"] = internet_bandwidth_max_out
            __props__.__dict__["internet_charge_type"] = internet_charge_type
            __props__.__dict__["load_balancer_pass_to_target"] = load_balancer_pass_to_target
            __props__.__dict__["log_set_id"] = log_set_id
            __props__.__dict__["log_topic_id"] = log_topic_id
            __props__.__dict__["master_zone_id"] = master_zone_id
            if network_type is None and not opts.urn:
                raise TypeError("Missing required property 'network_type'")
            __props__.__dict__["network_type"] = network_type
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["security_groups"] = security_groups
            __props__.__dict__["slave_zone_id"] = slave_zone_id
            __props__.__dict__["snat_ips"] = snat_ips
            __props__.__dict__["snat_pro"] = snat_pro
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["tags"] = tags
            __props__.__dict__["target_region_info_region"] = target_region_info_region
            __props__.__dict__["target_region_info_vpc_id"] = target_region_info_vpc_id
            __props__.__dict__["vpc_id"] = vpc_id
            __props__.__dict__["zone_id"] = zone_id
            __props__.__dict__["clb_vips"] = None
            __props__.__dict__["vip_isp"] = None
        super(Instance, __self__).__init__(
            'tencentcloud:Clb/instance:Instance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            address_ip_version: Optional[pulumi.Input[str]] = None,
            bandwidth_package_id: Optional[pulumi.Input[str]] = None,
            clb_name: Optional[pulumi.Input[str]] = None,
            clb_vips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            internet_bandwidth_max_out: Optional[pulumi.Input[int]] = None,
            internet_charge_type: Optional[pulumi.Input[str]] = None,
            load_balancer_pass_to_target: Optional[pulumi.Input[bool]] = None,
            log_set_id: Optional[pulumi.Input[str]] = None,
            log_topic_id: Optional[pulumi.Input[str]] = None,
            master_zone_id: Optional[pulumi.Input[str]] = None,
            network_type: Optional[pulumi.Input[str]] = None,
            project_id: Optional[pulumi.Input[int]] = None,
            security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            slave_zone_id: Optional[pulumi.Input[str]] = None,
            snat_ips: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSnatIpArgs']]]]] = None,
            snat_pro: Optional[pulumi.Input[bool]] = None,
            subnet_id: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            target_region_info_region: Optional[pulumi.Input[str]] = None,
            target_region_info_vpc_id: Optional[pulumi.Input[str]] = None,
            vip_isp: Optional[pulumi.Input[str]] = None,
            vpc_id: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'Instance':
        """
        Get an existing Instance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_ip_version: IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        :param pulumi.Input[str] bandwidth_package_id: Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[str] clb_name: Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] clb_vips: The virtual service address table of the CLB.
        :param pulumi.Input[int] internet_bandwidth_max_out: Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        :param pulumi.Input[str] internet_charge_type: Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        :param pulumi.Input[bool] load_balancer_pass_to_target: Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        :param pulumi.Input[str] log_set_id: The id of log set.
        :param pulumi.Input[str] log_topic_id: The id of log topic.
        :param pulumi.Input[str] master_zone_id: Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        :param pulumi.Input[str] network_type: Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        :param pulumi.Input[int] project_id: ID of the project within the CLB instance, `0` - Default Project.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        :param pulumi.Input[str] slave_zone_id: Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSnatIpArgs']]]] snat_ips: Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        :param pulumi.Input[bool] snat_pro: Indicates whether Binding IPs of other VPCs feature switch.
        :param pulumi.Input[str] subnet_id: Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        :param pulumi.Input[Mapping[str, Any]] tags: The available tags within this CLB.
        :param pulumi.Input[str] target_region_info_region: Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] target_region_info_vpc_id: Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        :param pulumi.Input[str] vip_isp: Network operator, only applicable to open CLB. Valid values are `CMCC`(China Mobile), `CTCC`(Telecom), `CUCC`(China Unicom) and `BGP`. If this ISP is specified, network billing method can only use the bandwidth package billing (BANDWIDTH_PACKAGE).
        :param pulumi.Input[str] vpc_id: VPC ID of the CLB.
        :param pulumi.Input[str] zone_id: Available zone id, only applicable to open CLB.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceState.__new__(_InstanceState)

        __props__.__dict__["address_ip_version"] = address_ip_version
        __props__.__dict__["bandwidth_package_id"] = bandwidth_package_id
        __props__.__dict__["clb_name"] = clb_name
        __props__.__dict__["clb_vips"] = clb_vips
        __props__.__dict__["internet_bandwidth_max_out"] = internet_bandwidth_max_out
        __props__.__dict__["internet_charge_type"] = internet_charge_type
        __props__.__dict__["load_balancer_pass_to_target"] = load_balancer_pass_to_target
        __props__.__dict__["log_set_id"] = log_set_id
        __props__.__dict__["log_topic_id"] = log_topic_id
        __props__.__dict__["master_zone_id"] = master_zone_id
        __props__.__dict__["network_type"] = network_type
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["security_groups"] = security_groups
        __props__.__dict__["slave_zone_id"] = slave_zone_id
        __props__.__dict__["snat_ips"] = snat_ips
        __props__.__dict__["snat_pro"] = snat_pro
        __props__.__dict__["subnet_id"] = subnet_id
        __props__.__dict__["tags"] = tags
        __props__.__dict__["target_region_info_region"] = target_region_info_region
        __props__.__dict__["target_region_info_vpc_id"] = target_region_info_vpc_id
        __props__.__dict__["vip_isp"] = vip_isp
        __props__.__dict__["vpc_id"] = vpc_id
        __props__.__dict__["zone_id"] = zone_id
        return Instance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addressIpVersion")
    def address_ip_version(self) -> pulumi.Output[str]:
        """
        IP version, only applicable to open CLB. Valid values are `ipv4`, `ipv6` and `IPv6FullChain`.
        """
        return pulumi.get(self, "address_ip_version")

    @property
    @pulumi.getter(name="bandwidthPackageId")
    def bandwidth_package_id(self) -> pulumi.Output[Optional[str]]:
        """
        Bandwidth package id. If set, the `internet_charge_type` must be `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "bandwidth_package_id")

    @property
    @pulumi.getter(name="clbName")
    def clb_name(self) -> pulumi.Output[str]:
        """
        Name of the CLB. The name can only contain Chinese characters, English letters, numbers, underscore and hyphen '-'.
        """
        return pulumi.get(self, "clb_name")

    @property
    @pulumi.getter(name="clbVips")
    def clb_vips(self) -> pulumi.Output[Sequence[str]]:
        """
        The virtual service address table of the CLB.
        """
        return pulumi.get(self, "clb_vips")

    @property
    @pulumi.getter(name="internetBandwidthMaxOut")
    def internet_bandwidth_max_out(self) -> pulumi.Output[int]:
        """
        Max bandwidth out, only applicable to open CLB. Valid value ranges is [1, 2048]. Unit is MB.
        """
        return pulumi.get(self, "internet_bandwidth_max_out")

    @property
    @pulumi.getter(name="internetChargeType")
    def internet_charge_type(self) -> pulumi.Output[str]:
        """
        Internet charge type, only applicable to open CLB. Valid values are `TRAFFIC_POSTPAID_BY_HOUR`, `BANDWIDTH_POSTPAID_BY_HOUR` and `BANDWIDTH_PACKAGE`.
        """
        return pulumi.get(self, "internet_charge_type")

    @property
    @pulumi.getter(name="loadBalancerPassToTarget")
    def load_balancer_pass_to_target(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether the target allow flow come from clb. If value is true, only check security group of clb, or check both clb and backend instance security group.
        """
        return pulumi.get(self, "load_balancer_pass_to_target")

    @property
    @pulumi.getter(name="logSetId")
    def log_set_id(self) -> pulumi.Output[Optional[str]]:
        """
        The id of log set.
        """
        return pulumi.get(self, "log_set_id")

    @property
    @pulumi.getter(name="logTopicId")
    def log_topic_id(self) -> pulumi.Output[Optional[str]]:
        """
        The id of log topic.
        """
        return pulumi.get(self, "log_topic_id")

    @property
    @pulumi.getter(name="masterZoneId")
    def master_zone_id(self) -> pulumi.Output[Optional[str]]:
        """
        Setting master zone id of cross available zone disaster recovery, only applicable to open CLB.
        """
        return pulumi.get(self, "master_zone_id")

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> pulumi.Output[str]:
        """
        Type of CLB instance. Valid values: `OPEN` and `INTERNAL`.
        """
        return pulumi.get(self, "network_type")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[Optional[int]]:
        """
        ID of the project within the CLB instance, `0` - Default Project.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Security groups of the CLB instance. Supports both `OPEN` and `INTERNAL` CLBs.
        """
        return pulumi.get(self, "security_groups")

    @property
    @pulumi.getter(name="slaveZoneId")
    def slave_zone_id(self) -> pulumi.Output[Optional[str]]:
        """
        Setting slave zone id of cross available zone disaster recovery, only applicable to open CLB. this zone will undertake traffic when the master is down.
        """
        return pulumi.get(self, "slave_zone_id")

    @property
    @pulumi.getter(name="snatIps")
    def snat_ips(self) -> pulumi.Output[Optional[Sequence['outputs.InstanceSnatIp']]]:
        """
        Snat Ip List, required with `snat_pro=true`. NOTE: This argument cannot be read and modified here because dynamic ip is untraceable, please import resource `Clb.SnatIp` to handle fixed ips.
        """
        return pulumi.get(self, "snat_ips")

    @property
    @pulumi.getter(name="snatPro")
    def snat_pro(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether Binding IPs of other VPCs feature switch.
        """
        return pulumi.get(self, "snat_pro")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[Optional[str]]:
        """
        Subnet ID of the CLB. Effective only for CLB within the VPC. Only supports `INTERNAL` CLBs. Default is `ipv4`.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        """
        The available tags within this CLB.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="targetRegionInfoRegion")
    def target_region_info_region(self) -> pulumi.Output[str]:
        """
        Region information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_region")

    @property
    @pulumi.getter(name="targetRegionInfoVpcId")
    def target_region_info_vpc_id(self) -> pulumi.Output[str]:
        """
        Vpc information of backend services are attached the CLB instance. Only supports `OPEN` CLBs.
        """
        return pulumi.get(self, "target_region_info_vpc_id")

    @property
    @pulumi.getter(name="vipIsp")
    def vip_isp(self) -> pulumi.Output[str]:
        """
        Network operator, only applicable to open CLB. Valid values are `CMCC`(China Mobile), `CTCC`(Telecom), `CUCC`(China Unicom) and `BGP`. If this ISP is specified, network billing method can only use the bandwidth package billing (BANDWIDTH_PACKAGE).
        """
        return pulumi.get(self, "vip_isp")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[str]:
        """
        VPC ID of the CLB.
        """
        return pulumi.get(self, "vpc_id")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[Optional[str]]:
        """
        Available zone id, only applicable to open CLB.
        """
        return pulumi.get(self, "zone_id")

