# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'ConfigExcludePathArgs',
    'ConfigExtraContainerFileArgs',
    'ConfigExtraContainerFileWorkloadArgs',
    'ConfigExtraContainerStdoutArgs',
    'ConfigExtraContainerStdoutWorkloadArgs',
    'ConfigExtraExcludePathArgs',
    'ConfigExtraExtractRuleArgs',
    'ConfigExtraExtractRuleFilterKeyRegexArgs',
    'ConfigExtraHostFileArgs',
    'ConfigExtractRuleArgs',
    'ConfigExtractRuleFilterKeyRegexArgs',
    'CosShipperCompressArgs',
    'CosShipperContentArgs',
    'CosShipperContentCsvArgs',
    'CosShipperContentJsonArgs',
    'CosShipperFilterRuleArgs',
    'IndexRuleArgs',
    'IndexRuleFullTextArgs',
    'IndexRuleKeyValueArgs',
    'IndexRuleKeyValueKeyValueArgs',
    'IndexRuleKeyValueKeyValueValueArgs',
    'IndexRuleTagArgs',
    'IndexRuleTagKeyValueArgs',
    'IndexRuleTagKeyValueValueArgs',
    'MachineGroupMachineGroupTypeArgs',
]

@pulumi.input_type
class ConfigExcludePathArgs:
    def __init__(__self__, *,
                 type: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] type: Type. Valid values: File, Path.
        :param pulumi.Input[str] value: Specific content corresponding to Type.
        """
        if type is not None:
            pulumi.set(__self__, "type", type)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Type. Valid values: File, Path.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[str]]:
        """
        Specific content corresponding to Type.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class ConfigExtraContainerFileArgs:
    def __init__(__self__, *,
                 container: pulumi.Input[str],
                 file_pattern: pulumi.Input[str],
                 log_path: pulumi.Input[str],
                 namespace: pulumi.Input[str],
                 exclude_labels: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 exclude_namespace: Optional[pulumi.Input[str]] = None,
                 include_labels: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 workload: Optional[pulumi.Input['ConfigExtraContainerFileWorkloadArgs']] = None):
        """
        :param pulumi.Input[str] container: Container name.
        :param pulumi.Input[str] file_pattern: log name.
        :param pulumi.Input[str] log_path: Log Path.
        :param pulumi.Input[str] namespace: Namespace. There can be multiple namespaces, separated by separators, such as A, B.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] exclude_labels: Pod label to be excluded.
        :param pulumi.Input[str] exclude_namespace: Namespaces to be excluded, separated by separators, such as A, B.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] include_labels: Pod label info.
        :param pulumi.Input['ConfigExtraContainerFileWorkloadArgs'] workload: Workload info.
        """
        pulumi.set(__self__, "container", container)
        pulumi.set(__self__, "file_pattern", file_pattern)
        pulumi.set(__self__, "log_path", log_path)
        pulumi.set(__self__, "namespace", namespace)
        if exclude_labels is not None:
            pulumi.set(__self__, "exclude_labels", exclude_labels)
        if exclude_namespace is not None:
            pulumi.set(__self__, "exclude_namespace", exclude_namespace)
        if include_labels is not None:
            pulumi.set(__self__, "include_labels", include_labels)
        if workload is not None:
            pulumi.set(__self__, "workload", workload)

    @property
    @pulumi.getter
    def container(self) -> pulumi.Input[str]:
        """
        Container name.
        """
        return pulumi.get(self, "container")

    @container.setter
    def container(self, value: pulumi.Input[str]):
        pulumi.set(self, "container", value)

    @property
    @pulumi.getter(name="filePattern")
    def file_pattern(self) -> pulumi.Input[str]:
        """
        log name.
        """
        return pulumi.get(self, "file_pattern")

    @file_pattern.setter
    def file_pattern(self, value: pulumi.Input[str]):
        pulumi.set(self, "file_pattern", value)

    @property
    @pulumi.getter(name="logPath")
    def log_path(self) -> pulumi.Input[str]:
        """
        Log Path.
        """
        return pulumi.get(self, "log_path")

    @log_path.setter
    def log_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "log_path", value)

    @property
    @pulumi.getter
    def namespace(self) -> pulumi.Input[str]:
        """
        Namespace. There can be multiple namespaces, separated by separators, such as A, B.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: pulumi.Input[str]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter(name="excludeLabels")
    def exclude_labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Pod label to be excluded.
        """
        return pulumi.get(self, "exclude_labels")

    @exclude_labels.setter
    def exclude_labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "exclude_labels", value)

    @property
    @pulumi.getter(name="excludeNamespace")
    def exclude_namespace(self) -> Optional[pulumi.Input[str]]:
        """
        Namespaces to be excluded, separated by separators, such as A, B.
        """
        return pulumi.get(self, "exclude_namespace")

    @exclude_namespace.setter
    def exclude_namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "exclude_namespace", value)

    @property
    @pulumi.getter(name="includeLabels")
    def include_labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Pod label info.
        """
        return pulumi.get(self, "include_labels")

    @include_labels.setter
    def include_labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "include_labels", value)

    @property
    @pulumi.getter
    def workload(self) -> Optional[pulumi.Input['ConfigExtraContainerFileWorkloadArgs']]:
        """
        Workload info.
        """
        return pulumi.get(self, "workload")

    @workload.setter
    def workload(self, value: Optional[pulumi.Input['ConfigExtraContainerFileWorkloadArgs']]):
        pulumi.set(self, "workload", value)


@pulumi.input_type
class ConfigExtraContainerFileWorkloadArgs:
    def __init__(__self__, *,
                 kind: pulumi.Input[str],
                 name: pulumi.Input[str],
                 container: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] kind: workload type.
        :param pulumi.Input[str] name: workload name.
        :param pulumi.Input[str] container: container name.
        :param pulumi.Input[str] namespace: namespace.
        """
        pulumi.set(__self__, "kind", kind)
        pulumi.set(__self__, "name", name)
        if container is not None:
            pulumi.set(__self__, "container", container)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Input[str]:
        """
        workload type.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: pulumi.Input[str]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        workload name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def container(self) -> Optional[pulumi.Input[str]]:
        """
        container name.
        """
        return pulumi.get(self, "container")

    @container.setter
    def container(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "container", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[str]]:
        """
        namespace.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "namespace", value)


@pulumi.input_type
class ConfigExtraContainerStdoutArgs:
    def __init__(__self__, *,
                 all_containers: pulumi.Input[bool],
                 exclude_labels: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 exclude_namespace: Optional[pulumi.Input[str]] = None,
                 include_labels: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 namespace: Optional[pulumi.Input[str]] = None,
                 workloads: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraContainerStdoutWorkloadArgs']]]] = None):
        """
        :param pulumi.Input[bool] all_containers: Is all containers.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] exclude_labels: Pod label to be excluded.
        :param pulumi.Input[str] exclude_namespace: Namespaces to be excluded, separated by separators, such as A, B.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] include_labels: Pod label info.
        :param pulumi.Input[str] namespace: Namespace. There can be multiple namespaces, separated by separators, such as A, B.
        :param pulumi.Input[Sequence[pulumi.Input['ConfigExtraContainerStdoutWorkloadArgs']]] workloads: Workload info.
        """
        pulumi.set(__self__, "all_containers", all_containers)
        if exclude_labels is not None:
            pulumi.set(__self__, "exclude_labels", exclude_labels)
        if exclude_namespace is not None:
            pulumi.set(__self__, "exclude_namespace", exclude_namespace)
        if include_labels is not None:
            pulumi.set(__self__, "include_labels", include_labels)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)
        if workloads is not None:
            pulumi.set(__self__, "workloads", workloads)

    @property
    @pulumi.getter(name="allContainers")
    def all_containers(self) -> pulumi.Input[bool]:
        """
        Is all containers.
        """
        return pulumi.get(self, "all_containers")

    @all_containers.setter
    def all_containers(self, value: pulumi.Input[bool]):
        pulumi.set(self, "all_containers", value)

    @property
    @pulumi.getter(name="excludeLabels")
    def exclude_labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Pod label to be excluded.
        """
        return pulumi.get(self, "exclude_labels")

    @exclude_labels.setter
    def exclude_labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "exclude_labels", value)

    @property
    @pulumi.getter(name="excludeNamespace")
    def exclude_namespace(self) -> Optional[pulumi.Input[str]]:
        """
        Namespaces to be excluded, separated by separators, such as A, B.
        """
        return pulumi.get(self, "exclude_namespace")

    @exclude_namespace.setter
    def exclude_namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "exclude_namespace", value)

    @property
    @pulumi.getter(name="includeLabels")
    def include_labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Pod label info.
        """
        return pulumi.get(self, "include_labels")

    @include_labels.setter
    def include_labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "include_labels", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[str]]:
        """
        Namespace. There can be multiple namespaces, separated by separators, such as A, B.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter
    def workloads(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraContainerStdoutWorkloadArgs']]]]:
        """
        Workload info.
        """
        return pulumi.get(self, "workloads")

    @workloads.setter
    def workloads(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraContainerStdoutWorkloadArgs']]]]):
        pulumi.set(self, "workloads", value)


@pulumi.input_type
class ConfigExtraContainerStdoutWorkloadArgs:
    def __init__(__self__, *,
                 kind: pulumi.Input[str],
                 name: pulumi.Input[str],
                 container: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] kind: workload type.
        :param pulumi.Input[str] name: workload name.
        :param pulumi.Input[str] container: container name.
        :param pulumi.Input[str] namespace: namespace.
        """
        pulumi.set(__self__, "kind", kind)
        pulumi.set(__self__, "name", name)
        if container is not None:
            pulumi.set(__self__, "container", container)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Input[str]:
        """
        workload type.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: pulumi.Input[str]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        workload name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def container(self) -> Optional[pulumi.Input[str]]:
        """
        container name.
        """
        return pulumi.get(self, "container")

    @container.setter
    def container(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "container", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[str]]:
        """
        namespace.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "namespace", value)


@pulumi.input_type
class ConfigExtraExcludePathArgs:
    def __init__(__self__, *,
                 type: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] type: Type. Valid values: File, Path.
        :param pulumi.Input[str] value: Specific content corresponding to Type.
        """
        if type is not None:
            pulumi.set(__self__, "type", type)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Type. Valid values: File, Path.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[str]]:
        """
        Specific content corresponding to Type.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class ConfigExtraExtractRuleArgs:
    def __init__(__self__, *,
                 backtracking: Optional[pulumi.Input[int]] = None,
                 begin_regex: Optional[pulumi.Input[str]] = None,
                 delimiter: Optional[pulumi.Input[str]] = None,
                 filter_key_regexes: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraExtractRuleFilterKeyRegexArgs']]]] = None,
                 keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_regex: Optional[pulumi.Input[str]] = None,
                 time_format: Optional[pulumi.Input[str]] = None,
                 time_key: Optional[pulumi.Input[str]] = None,
                 un_match_log_key: Optional[pulumi.Input[str]] = None,
                 un_match_up_load_switch: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[int] backtracking: Size of the data to be rewound in incremental collection mode. Default value: -1 (full collection).
        :param pulumi.Input[str] begin_regex: First-Line matching rule, which is valid only if log_type is multiline_log or fullregex_log.
        :param pulumi.Input[str] delimiter: Delimiter for delimited log, which is valid only if log_type is delimiter_log.
        :param pulumi.Input[Sequence[pulumi.Input['ConfigExtraExtractRuleFilterKeyRegexArgs']]] filter_key_regexes: Log keys to be filtered and the corresponding regex.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] keys: Key name of each extracted field. An empty key indicates to discard the field. This parameter is valid only if log_type is delimiter_log. json_log logs use the key of JSON itself.
        :param pulumi.Input[str] log_regex: Full log matching rule, which is valid only if log_type is fullregex_log.
        :param pulumi.Input[str] time_format: Time field format. For more information, please see the output parameters of the time format description of the strftime function in C language.
        :param pulumi.Input[str] time_key: Time field key name. time_key and time_format must appear in pair.
        :param pulumi.Input[str] un_match_log_key: Unmatched log key.
        :param pulumi.Input[bool] un_match_up_load_switch: Whether to upload the logs that failed to be parsed. Valid values: true: yes; false: no.
        """
        if backtracking is not None:
            pulumi.set(__self__, "backtracking", backtracking)
        if begin_regex is not None:
            pulumi.set(__self__, "begin_regex", begin_regex)
        if delimiter is not None:
            pulumi.set(__self__, "delimiter", delimiter)
        if filter_key_regexes is not None:
            pulumi.set(__self__, "filter_key_regexes", filter_key_regexes)
        if keys is not None:
            pulumi.set(__self__, "keys", keys)
        if log_regex is not None:
            pulumi.set(__self__, "log_regex", log_regex)
        if time_format is not None:
            pulumi.set(__self__, "time_format", time_format)
        if time_key is not None:
            pulumi.set(__self__, "time_key", time_key)
        if un_match_log_key is not None:
            pulumi.set(__self__, "un_match_log_key", un_match_log_key)
        if un_match_up_load_switch is not None:
            pulumi.set(__self__, "un_match_up_load_switch", un_match_up_load_switch)

    @property
    @pulumi.getter
    def backtracking(self) -> Optional[pulumi.Input[int]]:
        """
        Size of the data to be rewound in incremental collection mode. Default value: -1 (full collection).
        """
        return pulumi.get(self, "backtracking")

    @backtracking.setter
    def backtracking(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "backtracking", value)

    @property
    @pulumi.getter(name="beginRegex")
    def begin_regex(self) -> Optional[pulumi.Input[str]]:
        """
        First-Line matching rule, which is valid only if log_type is multiline_log or fullregex_log.
        """
        return pulumi.get(self, "begin_regex")

    @begin_regex.setter
    def begin_regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "begin_regex", value)

    @property
    @pulumi.getter
    def delimiter(self) -> Optional[pulumi.Input[str]]:
        """
        Delimiter for delimited log, which is valid only if log_type is delimiter_log.
        """
        return pulumi.get(self, "delimiter")

    @delimiter.setter
    def delimiter(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delimiter", value)

    @property
    @pulumi.getter(name="filterKeyRegexes")
    def filter_key_regexes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraExtractRuleFilterKeyRegexArgs']]]]:
        """
        Log keys to be filtered and the corresponding regex.
        """
        return pulumi.get(self, "filter_key_regexes")

    @filter_key_regexes.setter
    def filter_key_regexes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtraExtractRuleFilterKeyRegexArgs']]]]):
        pulumi.set(self, "filter_key_regexes", value)

    @property
    @pulumi.getter
    def keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Key name of each extracted field. An empty key indicates to discard the field. This parameter is valid only if log_type is delimiter_log. json_log logs use the key of JSON itself.
        """
        return pulumi.get(self, "keys")

    @keys.setter
    def keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "keys", value)

    @property
    @pulumi.getter(name="logRegex")
    def log_regex(self) -> Optional[pulumi.Input[str]]:
        """
        Full log matching rule, which is valid only if log_type is fullregex_log.
        """
        return pulumi.get(self, "log_regex")

    @log_regex.setter
    def log_regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_regex", value)

    @property
    @pulumi.getter(name="timeFormat")
    def time_format(self) -> Optional[pulumi.Input[str]]:
        """
        Time field format. For more information, please see the output parameters of the time format description of the strftime function in C language.
        """
        return pulumi.get(self, "time_format")

    @time_format.setter
    def time_format(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_format", value)

    @property
    @pulumi.getter(name="timeKey")
    def time_key(self) -> Optional[pulumi.Input[str]]:
        """
        Time field key name. time_key and time_format must appear in pair.
        """
        return pulumi.get(self, "time_key")

    @time_key.setter
    def time_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_key", value)

    @property
    @pulumi.getter(name="unMatchLogKey")
    def un_match_log_key(self) -> Optional[pulumi.Input[str]]:
        """
        Unmatched log key.
        """
        return pulumi.get(self, "un_match_log_key")

    @un_match_log_key.setter
    def un_match_log_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "un_match_log_key", value)

    @property
    @pulumi.getter(name="unMatchUpLoadSwitch")
    def un_match_up_load_switch(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to upload the logs that failed to be parsed. Valid values: true: yes; false: no.
        """
        return pulumi.get(self, "un_match_up_load_switch")

    @un_match_up_load_switch.setter
    def un_match_up_load_switch(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "un_match_up_load_switch", value)


@pulumi.input_type
class ConfigExtraExtractRuleFilterKeyRegexArgs:
    def __init__(__self__, *,
                 key: Optional[pulumi.Input[str]] = None,
                 regex: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] key: Log key to be filtered.
        :param pulumi.Input[str] regex: Filter rule regex corresponding to key.
        """
        if key is not None:
            pulumi.set(__self__, "key", key)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Log key to be filtered.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[pulumi.Input[str]]:
        """
        Filter rule regex corresponding to key.
        """
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "regex", value)


@pulumi.input_type
class ConfigExtraHostFileArgs:
    def __init__(__self__, *,
                 file_pattern: pulumi.Input[str],
                 log_path: pulumi.Input[str],
                 custom_labels: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[str] file_pattern: Log file name.
        :param pulumi.Input[str] log_path: Log file dir.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] custom_labels: Metadata info.
        """
        pulumi.set(__self__, "file_pattern", file_pattern)
        pulumi.set(__self__, "log_path", log_path)
        if custom_labels is not None:
            pulumi.set(__self__, "custom_labels", custom_labels)

    @property
    @pulumi.getter(name="filePattern")
    def file_pattern(self) -> pulumi.Input[str]:
        """
        Log file name.
        """
        return pulumi.get(self, "file_pattern")

    @file_pattern.setter
    def file_pattern(self, value: pulumi.Input[str]):
        pulumi.set(self, "file_pattern", value)

    @property
    @pulumi.getter(name="logPath")
    def log_path(self) -> pulumi.Input[str]:
        """
        Log file dir.
        """
        return pulumi.get(self, "log_path")

    @log_path.setter
    def log_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "log_path", value)

    @property
    @pulumi.getter(name="customLabels")
    def custom_labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Metadata info.
        """
        return pulumi.get(self, "custom_labels")

    @custom_labels.setter
    def custom_labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "custom_labels", value)


@pulumi.input_type
class ConfigExtractRuleArgs:
    def __init__(__self__, *,
                 backtracking: Optional[pulumi.Input[int]] = None,
                 begin_regex: Optional[pulumi.Input[str]] = None,
                 delimiter: Optional[pulumi.Input[str]] = None,
                 filter_key_regexes: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtractRuleFilterKeyRegexArgs']]]] = None,
                 keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_regex: Optional[pulumi.Input[str]] = None,
                 time_format: Optional[pulumi.Input[str]] = None,
                 time_key: Optional[pulumi.Input[str]] = None,
                 un_match_log_key: Optional[pulumi.Input[str]] = None,
                 un_match_up_load_switch: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[int] backtracking: Size of the data to be rewound in incremental collection mode. Default value: -1 (full collection).
        :param pulumi.Input[str] begin_regex: First-Line matching rule, which is valid only if log_type is multiline_log or fullregex_log.
        :param pulumi.Input[str] delimiter: Delimiter for delimited log, which is valid only if log_type is delimiter_log.
        :param pulumi.Input[Sequence[pulumi.Input['ConfigExtractRuleFilterKeyRegexArgs']]] filter_key_regexes: Log keys to be filtered and the corresponding regex.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] keys: Key name of each extracted field. An empty key indicates to discard the field. This parameter is valid only if log_type is delimiter_log. json_log logs use the key of JSON itself.
        :param pulumi.Input[str] log_regex: Full log matching rule, which is valid only if log_type is fullregex_log.
        :param pulumi.Input[str] time_format: Time field format. For more information, please see the output parameters of the time format description of the strftime function in C language.
        :param pulumi.Input[str] time_key: Time field key name. time_key and time_format must appear in pair.
        :param pulumi.Input[str] un_match_log_key: Unmatched log key.
        :param pulumi.Input[bool] un_match_up_load_switch: Whether to upload the logs that failed to be parsed. Valid values: true: yes; false: no.
        """
        if backtracking is not None:
            pulumi.set(__self__, "backtracking", backtracking)
        if begin_regex is not None:
            pulumi.set(__self__, "begin_regex", begin_regex)
        if delimiter is not None:
            pulumi.set(__self__, "delimiter", delimiter)
        if filter_key_regexes is not None:
            pulumi.set(__self__, "filter_key_regexes", filter_key_regexes)
        if keys is not None:
            pulumi.set(__self__, "keys", keys)
        if log_regex is not None:
            pulumi.set(__self__, "log_regex", log_regex)
        if time_format is not None:
            pulumi.set(__self__, "time_format", time_format)
        if time_key is not None:
            pulumi.set(__self__, "time_key", time_key)
        if un_match_log_key is not None:
            pulumi.set(__self__, "un_match_log_key", un_match_log_key)
        if un_match_up_load_switch is not None:
            pulumi.set(__self__, "un_match_up_load_switch", un_match_up_load_switch)

    @property
    @pulumi.getter
    def backtracking(self) -> Optional[pulumi.Input[int]]:
        """
        Size of the data to be rewound in incremental collection mode. Default value: -1 (full collection).
        """
        return pulumi.get(self, "backtracking")

    @backtracking.setter
    def backtracking(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "backtracking", value)

    @property
    @pulumi.getter(name="beginRegex")
    def begin_regex(self) -> Optional[pulumi.Input[str]]:
        """
        First-Line matching rule, which is valid only if log_type is multiline_log or fullregex_log.
        """
        return pulumi.get(self, "begin_regex")

    @begin_regex.setter
    def begin_regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "begin_regex", value)

    @property
    @pulumi.getter
    def delimiter(self) -> Optional[pulumi.Input[str]]:
        """
        Delimiter for delimited log, which is valid only if log_type is delimiter_log.
        """
        return pulumi.get(self, "delimiter")

    @delimiter.setter
    def delimiter(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delimiter", value)

    @property
    @pulumi.getter(name="filterKeyRegexes")
    def filter_key_regexes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtractRuleFilterKeyRegexArgs']]]]:
        """
        Log keys to be filtered and the corresponding regex.
        """
        return pulumi.get(self, "filter_key_regexes")

    @filter_key_regexes.setter
    def filter_key_regexes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigExtractRuleFilterKeyRegexArgs']]]]):
        pulumi.set(self, "filter_key_regexes", value)

    @property
    @pulumi.getter
    def keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Key name of each extracted field. An empty key indicates to discard the field. This parameter is valid only if log_type is delimiter_log. json_log logs use the key of JSON itself.
        """
        return pulumi.get(self, "keys")

    @keys.setter
    def keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "keys", value)

    @property
    @pulumi.getter(name="logRegex")
    def log_regex(self) -> Optional[pulumi.Input[str]]:
        """
        Full log matching rule, which is valid only if log_type is fullregex_log.
        """
        return pulumi.get(self, "log_regex")

    @log_regex.setter
    def log_regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_regex", value)

    @property
    @pulumi.getter(name="timeFormat")
    def time_format(self) -> Optional[pulumi.Input[str]]:
        """
        Time field format. For more information, please see the output parameters of the time format description of the strftime function in C language.
        """
        return pulumi.get(self, "time_format")

    @time_format.setter
    def time_format(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_format", value)

    @property
    @pulumi.getter(name="timeKey")
    def time_key(self) -> Optional[pulumi.Input[str]]:
        """
        Time field key name. time_key and time_format must appear in pair.
        """
        return pulumi.get(self, "time_key")

    @time_key.setter
    def time_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_key", value)

    @property
    @pulumi.getter(name="unMatchLogKey")
    def un_match_log_key(self) -> Optional[pulumi.Input[str]]:
        """
        Unmatched log key.
        """
        return pulumi.get(self, "un_match_log_key")

    @un_match_log_key.setter
    def un_match_log_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "un_match_log_key", value)

    @property
    @pulumi.getter(name="unMatchUpLoadSwitch")
    def un_match_up_load_switch(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to upload the logs that failed to be parsed. Valid values: true: yes; false: no.
        """
        return pulumi.get(self, "un_match_up_load_switch")

    @un_match_up_load_switch.setter
    def un_match_up_load_switch(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "un_match_up_load_switch", value)


@pulumi.input_type
class ConfigExtractRuleFilterKeyRegexArgs:
    def __init__(__self__, *,
                 key: Optional[pulumi.Input[str]] = None,
                 regex: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] key: Log key to be filtered.
        :param pulumi.Input[str] regex: Filter rule regex corresponding to key.
        """
        if key is not None:
            pulumi.set(__self__, "key", key)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Log key to be filtered.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[pulumi.Input[str]]:
        """
        Filter rule regex corresponding to key.
        """
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "regex", value)


@pulumi.input_type
class CosShipperCompressArgs:
    def __init__(__self__, *,
                 format: pulumi.Input[str]):
        """
        :param pulumi.Input[str] format: Compression format. Valid values: gzip, lzop, none (no compression).
        """
        pulumi.set(__self__, "format", format)

    @property
    @pulumi.getter
    def format(self) -> pulumi.Input[str]:
        """
        Compression format. Valid values: gzip, lzop, none (no compression).
        """
        return pulumi.get(self, "format")

    @format.setter
    def format(self, value: pulumi.Input[str]):
        pulumi.set(self, "format", value)


@pulumi.input_type
class CosShipperContentArgs:
    def __init__(__self__, *,
                 format: pulumi.Input[str],
                 csv: Optional[pulumi.Input['CosShipperContentCsvArgs']] = None,
                 json: Optional[pulumi.Input['CosShipperContentJsonArgs']] = None):
        """
        :param pulumi.Input[str] format: Content format. Valid values: json, csv.
        :param pulumi.Input['CosShipperContentCsvArgs'] csv: CSV format content description.Note: this field may return null, indicating that no valid values can be obtained.
        :param pulumi.Input['CosShipperContentJsonArgs'] json: JSON format content description.Note: this field may return null, indicating that no valid values can be obtained.
        """
        pulumi.set(__self__, "format", format)
        if csv is not None:
            pulumi.set(__self__, "csv", csv)
        if json is not None:
            pulumi.set(__self__, "json", json)

    @property
    @pulumi.getter
    def format(self) -> pulumi.Input[str]:
        """
        Content format. Valid values: json, csv.
        """
        return pulumi.get(self, "format")

    @format.setter
    def format(self, value: pulumi.Input[str]):
        pulumi.set(self, "format", value)

    @property
    @pulumi.getter
    def csv(self) -> Optional[pulumi.Input['CosShipperContentCsvArgs']]:
        """
        CSV format content description.Note: this field may return null, indicating that no valid values can be obtained.
        """
        return pulumi.get(self, "csv")

    @csv.setter
    def csv(self, value: Optional[pulumi.Input['CosShipperContentCsvArgs']]):
        pulumi.set(self, "csv", value)

    @property
    @pulumi.getter
    def json(self) -> Optional[pulumi.Input['CosShipperContentJsonArgs']]:
        """
        JSON format content description.Note: this field may return null, indicating that no valid values can be obtained.
        """
        return pulumi.get(self, "json")

    @json.setter
    def json(self, value: Optional[pulumi.Input['CosShipperContentJsonArgs']]):
        pulumi.set(self, "json", value)


@pulumi.input_type
class CosShipperContentCsvArgs:
    def __init__(__self__, *,
                 delimiter: pulumi.Input[str],
                 escape_char: pulumi.Input[str],
                 keys: pulumi.Input[Sequence[pulumi.Input[str]]],
                 non_existing_field: pulumi.Input[str],
                 print_key: pulumi.Input[bool]):
        """
        :param pulumi.Input[str] delimiter: Field delimiter.
        :param pulumi.Input[str] escape_char: Field delimiter.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] keys: Names of keys.Note: this field may return null, indicating that no valid values can be obtained.
        :param pulumi.Input[str] non_existing_field: Content used to populate non-existing fields.
        :param pulumi.Input[bool] print_key: Whether to print key on the first row of the CSV file.
        """
        pulumi.set(__self__, "delimiter", delimiter)
        pulumi.set(__self__, "escape_char", escape_char)
        pulumi.set(__self__, "keys", keys)
        pulumi.set(__self__, "non_existing_field", non_existing_field)
        pulumi.set(__self__, "print_key", print_key)

    @property
    @pulumi.getter
    def delimiter(self) -> pulumi.Input[str]:
        """
        Field delimiter.
        """
        return pulumi.get(self, "delimiter")

    @delimiter.setter
    def delimiter(self, value: pulumi.Input[str]):
        pulumi.set(self, "delimiter", value)

    @property
    @pulumi.getter(name="escapeChar")
    def escape_char(self) -> pulumi.Input[str]:
        """
        Field delimiter.
        """
        return pulumi.get(self, "escape_char")

    @escape_char.setter
    def escape_char(self, value: pulumi.Input[str]):
        pulumi.set(self, "escape_char", value)

    @property
    @pulumi.getter
    def keys(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Names of keys.Note: this field may return null, indicating that no valid values can be obtained.
        """
        return pulumi.get(self, "keys")

    @keys.setter
    def keys(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "keys", value)

    @property
    @pulumi.getter(name="nonExistingField")
    def non_existing_field(self) -> pulumi.Input[str]:
        """
        Content used to populate non-existing fields.
        """
        return pulumi.get(self, "non_existing_field")

    @non_existing_field.setter
    def non_existing_field(self, value: pulumi.Input[str]):
        pulumi.set(self, "non_existing_field", value)

    @property
    @pulumi.getter(name="printKey")
    def print_key(self) -> pulumi.Input[bool]:
        """
        Whether to print key on the first row of the CSV file.
        """
        return pulumi.get(self, "print_key")

    @print_key.setter
    def print_key(self, value: pulumi.Input[bool]):
        pulumi.set(self, "print_key", value)


@pulumi.input_type
class CosShipperContentJsonArgs:
    def __init__(__self__, *,
                 enable_tag: pulumi.Input[bool],
                 meta_fields: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[bool] enable_tag: Enablement flag.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] meta_fields: Metadata information list
               Note: this field may return null, indicating that no valid values can be obtained..
        """
        pulumi.set(__self__, "enable_tag", enable_tag)
        pulumi.set(__self__, "meta_fields", meta_fields)

    @property
    @pulumi.getter(name="enableTag")
    def enable_tag(self) -> pulumi.Input[bool]:
        """
        Enablement flag.
        """
        return pulumi.get(self, "enable_tag")

    @enable_tag.setter
    def enable_tag(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enable_tag", value)

    @property
    @pulumi.getter(name="metaFields")
    def meta_fields(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Metadata information list
        Note: this field may return null, indicating that no valid values can be obtained..
        """
        return pulumi.get(self, "meta_fields")

    @meta_fields.setter
    def meta_fields(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "meta_fields", value)


@pulumi.input_type
class CosShipperFilterRuleArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 regex: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        :param pulumi.Input[str] key: Filter rule key.
        :param pulumi.Input[str] regex: Filter rule.
        :param pulumi.Input[str] value: Filter rule value.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "regex", regex)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        Filter rule key.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def regex(self) -> pulumi.Input[str]:
        """
        Filter rule.
        """
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: pulumi.Input[str]):
        pulumi.set(self, "regex", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        Filter rule value.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class IndexRuleArgs:
    def __init__(__self__, *,
                 full_text: Optional[pulumi.Input['IndexRuleFullTextArgs']] = None,
                 key_value: Optional[pulumi.Input['IndexRuleKeyValueArgs']] = None,
                 tag: Optional[pulumi.Input['IndexRuleTagArgs']] = None):
        """
        :param pulumi.Input['IndexRuleFullTextArgs'] full_text: Full-Text index configuration.
        :param pulumi.Input['IndexRuleKeyValueArgs'] key_value: Key-Value index configuration.
        :param pulumi.Input['IndexRuleTagArgs'] tag: Metafield index configuration.
        """
        if full_text is not None:
            pulumi.set(__self__, "full_text", full_text)
        if key_value is not None:
            pulumi.set(__self__, "key_value", key_value)
        if tag is not None:
            pulumi.set(__self__, "tag", tag)

    @property
    @pulumi.getter(name="fullText")
    def full_text(self) -> Optional[pulumi.Input['IndexRuleFullTextArgs']]:
        """
        Full-Text index configuration.
        """
        return pulumi.get(self, "full_text")

    @full_text.setter
    def full_text(self, value: Optional[pulumi.Input['IndexRuleFullTextArgs']]):
        pulumi.set(self, "full_text", value)

    @property
    @pulumi.getter(name="keyValue")
    def key_value(self) -> Optional[pulumi.Input['IndexRuleKeyValueArgs']]:
        """
        Key-Value index configuration.
        """
        return pulumi.get(self, "key_value")

    @key_value.setter
    def key_value(self, value: Optional[pulumi.Input['IndexRuleKeyValueArgs']]):
        pulumi.set(self, "key_value", value)

    @property
    @pulumi.getter
    def tag(self) -> Optional[pulumi.Input['IndexRuleTagArgs']]:
        """
        Metafield index configuration.
        """
        return pulumi.get(self, "tag")

    @tag.setter
    def tag(self, value: Optional[pulumi.Input['IndexRuleTagArgs']]):
        pulumi.set(self, "tag", value)


@pulumi.input_type
class IndexRuleFullTextArgs:
    def __init__(__self__, *,
                 case_sensitive: pulumi.Input[bool],
                 contain_zh: pulumi.Input[bool],
                 tokenizer: pulumi.Input[str]):
        """
        :param pulumi.Input[bool] case_sensitive: Case sensitivity.
        :param pulumi.Input[bool] contain_zh: Whether Chinese characters are contained.
        :param pulumi.Input[str] tokenizer: Full-Text index delimiter. Each character in the string represents a delimiter.
        """
        pulumi.set(__self__, "case_sensitive", case_sensitive)
        pulumi.set(__self__, "contain_zh", contain_zh)
        pulumi.set(__self__, "tokenizer", tokenizer)

    @property
    @pulumi.getter(name="caseSensitive")
    def case_sensitive(self) -> pulumi.Input[bool]:
        """
        Case sensitivity.
        """
        return pulumi.get(self, "case_sensitive")

    @case_sensitive.setter
    def case_sensitive(self, value: pulumi.Input[bool]):
        pulumi.set(self, "case_sensitive", value)

    @property
    @pulumi.getter(name="containZH")
    def contain_zh(self) -> pulumi.Input[bool]:
        """
        Whether Chinese characters are contained.
        """
        return pulumi.get(self, "contain_zh")

    @contain_zh.setter
    def contain_zh(self, value: pulumi.Input[bool]):
        pulumi.set(self, "contain_zh", value)

    @property
    @pulumi.getter
    def tokenizer(self) -> pulumi.Input[str]:
        """
        Full-Text index delimiter. Each character in the string represents a delimiter.
        """
        return pulumi.get(self, "tokenizer")

    @tokenizer.setter
    def tokenizer(self, value: pulumi.Input[str]):
        pulumi.set(self, "tokenizer", value)


@pulumi.input_type
class IndexRuleKeyValueArgs:
    def __init__(__self__, *,
                 case_sensitive: pulumi.Input[bool],
                 key_values: Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleKeyValueKeyValueArgs']]]] = None):
        """
        :param pulumi.Input[bool] case_sensitive: Case sensitivity.
        :param pulumi.Input[Sequence[pulumi.Input['IndexRuleKeyValueKeyValueArgs']]] key_values: Key-Value pair information of the index to be created. Up to 100 key-value pairs can be configured.
        """
        pulumi.set(__self__, "case_sensitive", case_sensitive)
        if key_values is not None:
            pulumi.set(__self__, "key_values", key_values)

    @property
    @pulumi.getter(name="caseSensitive")
    def case_sensitive(self) -> pulumi.Input[bool]:
        """
        Case sensitivity.
        """
        return pulumi.get(self, "case_sensitive")

    @case_sensitive.setter
    def case_sensitive(self, value: pulumi.Input[bool]):
        pulumi.set(self, "case_sensitive", value)

    @property
    @pulumi.getter(name="keyValues")
    def key_values(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleKeyValueKeyValueArgs']]]]:
        """
        Key-Value pair information of the index to be created. Up to 100 key-value pairs can be configured.
        """
        return pulumi.get(self, "key_values")

    @key_values.setter
    def key_values(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleKeyValueKeyValueArgs']]]]):
        pulumi.set(self, "key_values", value)


@pulumi.input_type
class IndexRuleKeyValueKeyValueArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 value: Optional[pulumi.Input['IndexRuleKeyValueKeyValueValueArgs']] = None):
        """
        :param pulumi.Input[str] key: When a key value or metafield index needs to be configured for a field, the metafield Key does not need to be prefixed with __TAG__. and is consistent with the one when logs are uploaded. __TAG__. will be prefixed automatically for display in the console..
        :param pulumi.Input['IndexRuleKeyValueKeyValueValueArgs'] value: Field index description information.
        """
        pulumi.set(__self__, "key", key)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        When a key value or metafield index needs to be configured for a field, the metafield Key does not need to be prefixed with __TAG__. and is consistent with the one when logs are uploaded. __TAG__. will be prefixed automatically for display in the console..
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input['IndexRuleKeyValueKeyValueValueArgs']]:
        """
        Field index description information.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input['IndexRuleKeyValueKeyValueValueArgs']]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class IndexRuleKeyValueKeyValueValueArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 contain_zh: Optional[pulumi.Input[bool]] = None,
                 sql_flag: Optional[pulumi.Input[bool]] = None,
                 tokenizer: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] type: Field type. Valid values: long, text, double.
        :param pulumi.Input[bool] contain_zh: Whether Chinese characters are contained.
        :param pulumi.Input[bool] sql_flag: Whether the analysis feature is enabled for the field.
        :param pulumi.Input[str] tokenizer: Field delimiter, which is meaningful only if the field type is text. Each character in the entered string represents a delimiter.
        """
        pulumi.set(__self__, "type", type)
        if contain_zh is not None:
            pulumi.set(__self__, "contain_zh", contain_zh)
        if sql_flag is not None:
            pulumi.set(__self__, "sql_flag", sql_flag)
        if tokenizer is not None:
            pulumi.set(__self__, "tokenizer", tokenizer)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Field type. Valid values: long, text, double.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="containZH")
    def contain_zh(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether Chinese characters are contained.
        """
        return pulumi.get(self, "contain_zh")

    @contain_zh.setter
    def contain_zh(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "contain_zh", value)

    @property
    @pulumi.getter(name="sqlFlag")
    def sql_flag(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the analysis feature is enabled for the field.
        """
        return pulumi.get(self, "sql_flag")

    @sql_flag.setter
    def sql_flag(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_flag", value)

    @property
    @pulumi.getter
    def tokenizer(self) -> Optional[pulumi.Input[str]]:
        """
        Field delimiter, which is meaningful only if the field type is text. Each character in the entered string represents a delimiter.
        """
        return pulumi.get(self, "tokenizer")

    @tokenizer.setter
    def tokenizer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tokenizer", value)


@pulumi.input_type
class IndexRuleTagArgs:
    def __init__(__self__, *,
                 case_sensitive: pulumi.Input[bool],
                 key_values: Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleTagKeyValueArgs']]]] = None):
        """
        :param pulumi.Input[bool] case_sensitive: Case sensitivity.
        :param pulumi.Input[Sequence[pulumi.Input['IndexRuleTagKeyValueArgs']]] key_values: Key-Value pair information of the index to be created. Up to 100 key-value pairs can be configured.
        """
        pulumi.set(__self__, "case_sensitive", case_sensitive)
        if key_values is not None:
            pulumi.set(__self__, "key_values", key_values)

    @property
    @pulumi.getter(name="caseSensitive")
    def case_sensitive(self) -> pulumi.Input[bool]:
        """
        Case sensitivity.
        """
        return pulumi.get(self, "case_sensitive")

    @case_sensitive.setter
    def case_sensitive(self, value: pulumi.Input[bool]):
        pulumi.set(self, "case_sensitive", value)

    @property
    @pulumi.getter(name="keyValues")
    def key_values(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleTagKeyValueArgs']]]]:
        """
        Key-Value pair information of the index to be created. Up to 100 key-value pairs can be configured.
        """
        return pulumi.get(self, "key_values")

    @key_values.setter
    def key_values(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IndexRuleTagKeyValueArgs']]]]):
        pulumi.set(self, "key_values", value)


@pulumi.input_type
class IndexRuleTagKeyValueArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 value: Optional[pulumi.Input['IndexRuleTagKeyValueValueArgs']] = None):
        """
        :param pulumi.Input[str] key: When a key value or metafield index needs to be configured for a field, the metafield Key does not need to be prefixed with __TAG__. and is consistent with the one when logs are uploaded. __TAG__. will be prefixed automatically for display in the console..
        :param pulumi.Input['IndexRuleTagKeyValueValueArgs'] value: Field index description information.
        """
        pulumi.set(__self__, "key", key)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        When a key value or metafield index needs to be configured for a field, the metafield Key does not need to be prefixed with __TAG__. and is consistent with the one when logs are uploaded. __TAG__. will be prefixed automatically for display in the console..
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input['IndexRuleTagKeyValueValueArgs']]:
        """
        Field index description information.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input['IndexRuleTagKeyValueValueArgs']]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class IndexRuleTagKeyValueValueArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 contain_zh: Optional[pulumi.Input[bool]] = None,
                 sql_flag: Optional[pulumi.Input[bool]] = None,
                 tokenizer: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] type: Field type. Valid values: long, text, double.
        :param pulumi.Input[bool] contain_zh: Whether Chinese characters are contained.
        :param pulumi.Input[bool] sql_flag: Whether the analysis feature is enabled for the field.
        :param pulumi.Input[str] tokenizer: Field delimiter, which is meaningful only if the field type is text. Each character in the entered string represents a delimiter.
        """
        pulumi.set(__self__, "type", type)
        if contain_zh is not None:
            pulumi.set(__self__, "contain_zh", contain_zh)
        if sql_flag is not None:
            pulumi.set(__self__, "sql_flag", sql_flag)
        if tokenizer is not None:
            pulumi.set(__self__, "tokenizer", tokenizer)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Field type. Valid values: long, text, double.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="containZH")
    def contain_zh(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether Chinese characters are contained.
        """
        return pulumi.get(self, "contain_zh")

    @contain_zh.setter
    def contain_zh(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "contain_zh", value)

    @property
    @pulumi.getter(name="sqlFlag")
    def sql_flag(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the analysis feature is enabled for the field.
        """
        return pulumi.get(self, "sql_flag")

    @sql_flag.setter
    def sql_flag(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_flag", value)

    @property
    @pulumi.getter
    def tokenizer(self) -> Optional[pulumi.Input[str]]:
        """
        Field delimiter, which is meaningful only if the field type is text. Each character in the entered string represents a delimiter.
        """
        return pulumi.get(self, "tokenizer")

    @tokenizer.setter
    def tokenizer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tokenizer", value)


@pulumi.input_type
class MachineGroupMachineGroupTypeArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 values: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[str] type: Machine group type. Valid values: ip: the IP addresses of collection machines are stored in Values of the machine group; label: the tags of the machines are stored in Values of the machine group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] values: Machine description list.
        """
        pulumi.set(__self__, "type", type)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Machine group type. Valid values: ip: the IP addresses of collection machines are stored in Values of the machine group; label: the tags of the machines are stored in Values of the machine group.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def values(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Machine description list.
        """
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "values", value)


