# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetEipResult',
    'AwaitableGetEipResult',
    'get_eip',
    'get_eip_output',
]

@pulumi.output_type
class GetEipResult:
    """
    A collection of values returned by getEip.
    """
    def __init__(__self__, bind_statuses=None, id=None, limit=None, lists=None, offset=None, resource_id=None, result_output_file=None):
        if bind_statuses and not isinstance(bind_statuses, list):
            raise TypeError("Expected argument 'bind_statuses' to be a list")
        pulumi.set(__self__, "bind_statuses", bind_statuses)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if offset and not isinstance(offset, int):
            raise TypeError("Expected argument 'offset' to be a int")
        pulumi.set(__self__, "offset", offset)
        if resource_id and not isinstance(resource_id, str):
            raise TypeError("Expected argument 'resource_id' to be a str")
        pulumi.set(__self__, "resource_id", resource_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="bindStatuses")
    def bind_statuses(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "bind_statuses")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetEipListResult']:
        """
        A list of layer 4 rules. Each element contains the following attributes:
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter
    def offset(self) -> Optional[int]:
        return pulumi.get(self, "offset")

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> str:
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetEipResult(GetEipResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEipResult(
            bind_statuses=self.bind_statuses,
            id=self.id,
            limit=self.limit,
            lists=self.lists,
            offset=self.offset,
            resource_id=self.resource_id,
            result_output_file=self.result_output_file)


def get_eip(bind_statuses: Optional[Sequence[str]] = None,
            limit: Optional[int] = None,
            offset: Optional[int] = None,
            resource_id: Optional[str] = None,
            result_output_file: Optional[str] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEipResult:
    """
    Use this data source to query dayu eip rules

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    test = tencentcloud.Dayu.get_eip(resource_id="bgpip-000004xg")
    ```


    :param Sequence[str] bind_statuses: The binding state of the instance, value range [BINDING, BIND, UNBINDING, UNBIND], default is [BINDING, BIND, UNBINDING, UNBIND].
    :param int limit: The number of pages, default is `10`.
    :param int offset: The page start offset, default is `0`.
    :param str resource_id: Id of the resource.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['bindStatuses'] = bind_statuses
    __args__['limit'] = limit
    __args__['offset'] = offset
    __args__['resourceId'] = resource_id
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dayu/getEip:getEip', __args__, opts=opts, typ=GetEipResult).value

    return AwaitableGetEipResult(
        bind_statuses=__ret__.bind_statuses,
        id=__ret__.id,
        limit=__ret__.limit,
        lists=__ret__.lists,
        offset=__ret__.offset,
        resource_id=__ret__.resource_id,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_eip)
def get_eip_output(bind_statuses: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                   limit: Optional[pulumi.Input[Optional[int]]] = None,
                   offset: Optional[pulumi.Input[Optional[int]]] = None,
                   resource_id: Optional[pulumi.Input[str]] = None,
                   result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetEipResult]:
    """
    Use this data source to query dayu eip rules

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    test = tencentcloud.Dayu.get_eip(resource_id="bgpip-000004xg")
    ```


    :param Sequence[str] bind_statuses: The binding state of the instance, value range [BINDING, BIND, UNBINDING, UNBIND], default is [BINDING, BIND, UNBINDING, UNBIND].
    :param int limit: The number of pages, default is `10`.
    :param int offset: The page start offset, default is `0`.
    :param str resource_id: Id of the resource.
    :param str result_output_file: Used to save results.
    """
    ...
