# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetChartsResult',
    'AwaitableGetChartsResult',
    'get_charts',
    'get_charts_output',
]

@pulumi.output_type
class GetChartsResult:
    """
    A collection of values returned by getCharts.
    """
    def __init__(__self__, arch=None, chart_lists=None, cluster_type=None, id=None, kind=None, result_output_file=None):
        if arch and not isinstance(arch, str):
            raise TypeError("Expected argument 'arch' to be a str")
        pulumi.set(__self__, "arch", arch)
        if chart_lists and not isinstance(chart_lists, list):
            raise TypeError("Expected argument 'chart_lists' to be a list")
        pulumi.set(__self__, "chart_lists", chart_lists)
        if cluster_type and not isinstance(cluster_type, str):
            raise TypeError("Expected argument 'cluster_type' to be a str")
        pulumi.set(__self__, "cluster_type", cluster_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kind and not isinstance(kind, str):
            raise TypeError("Expected argument 'kind' to be a str")
        pulumi.set(__self__, "kind", kind)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def arch(self) -> Optional[str]:
        return pulumi.get(self, "arch")

    @property
    @pulumi.getter(name="chartLists")
    def chart_lists(self) -> Sequence['outputs.GetChartsChartListResult']:
        """
        App chart list.
        """
        return pulumi.get(self, "chart_lists")

    @property
    @pulumi.getter(name="clusterType")
    def cluster_type(self) -> Optional[str]:
        return pulumi.get(self, "cluster_type")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def kind(self) -> Optional[str]:
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetChartsResult(GetChartsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetChartsResult(
            arch=self.arch,
            chart_lists=self.chart_lists,
            cluster_type=self.cluster_type,
            id=self.id,
            kind=self.kind,
            result_output_file=self.result_output_file)


def get_charts(arch: Optional[str] = None,
               cluster_type: Optional[str] = None,
               kind: Optional[str] = None,
               result_output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetChartsResult:
    """
    Use this data source to query detailed information of kubernetes cluster addons.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Kubernetes.get_charts()
    ```


    :param str arch: Operation system app supported. Available values: `arm32`, `arm64`, `amd64`.
    :param str cluster_type: Cluster type. Available values: `tke`, `eks`.
    :param str kind: Kind of app chart. Available values: `log`, `scheduler`, `network`, `storage`, `monitor`, `dns`, `image`, `other`, `invisible`.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['arch'] = arch
    __args__['clusterType'] = cluster_type
    __args__['kind'] = kind
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Kubernetes/getCharts:getCharts', __args__, opts=opts, typ=GetChartsResult).value

    return AwaitableGetChartsResult(
        arch=__ret__.arch,
        chart_lists=__ret__.chart_lists,
        cluster_type=__ret__.cluster_type,
        id=__ret__.id,
        kind=__ret__.kind,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_charts)
def get_charts_output(arch: Optional[pulumi.Input[Optional[str]]] = None,
                      cluster_type: Optional[pulumi.Input[Optional[str]]] = None,
                      kind: Optional[pulumi.Input[Optional[str]]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetChartsResult]:
    """
    Use this data source to query detailed information of kubernetes cluster addons.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Kubernetes.get_charts()
    ```


    :param str arch: Operation system app supported. Available values: `arm32`, `arm64`, `amd64`.
    :param str cluster_type: Cluster type. Available values: `tke`, `eks`.
    :param str kind: Kind of app chart. Available values: `log`, `scheduler`, `network`, `storage`, `monitor`, `dns`, `image`, `other`, `invisible`.
    :param str result_output_file: Used to save results.
    """
    ...
