# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetClustersResult',
    'AwaitableGetClustersResult',
    'get_clusters',
    'get_clusters_output',
]

@pulumi.output_type
class GetClustersResult:
    """
    A collection of values returned by getClusters.
    """
    def __init__(__self__, cluster_id=None, cluster_name=None, id=None, lists=None, result_output_file=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if cluster_name and not isinstance(cluster_name, str):
            raise TypeError("Expected argument 'cluster_name' to be a str")
        pulumi.set(__self__, "cluster_name", cluster_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[str]:
        """
        ID of the TcaplusDB cluster.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> Optional[str]:
        """
        Name of the TcaplusDB cluster.
        """
        return pulumi.get(self, "cluster_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetClustersListResult']:
        """
        A list of TcaplusDB cluster. Each element contains the following attributes.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetClustersResult(GetClustersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClustersResult(
            cluster_id=self.cluster_id,
            cluster_name=self.cluster_name,
            id=self.id,
            lists=self.lists,
            result_output_file=self.result_output_file)


def get_clusters(cluster_id: Optional[str] = None,
                 cluster_name: Optional[str] = None,
                 result_output_file: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClustersResult:
    """
    Use this data source to query TcaplusDB clusters.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Tcaplus.get_clusters(cluster_name="cluster")
    id = tencentcloud.Tcaplus.get_clusters(cluster_id=tencentcloud_tcaplus_cluster["test"]["id"])
    idname = tencentcloud.Tcaplus.get_clusters(cluster_id=tencentcloud_tcaplus_cluster["test"]["id"],
        cluster_name="cluster")
    ```


    :param str cluster_id: ID of the TcaplusDB cluster to be query.
    :param str cluster_name: Name of the TcaplusDB cluster to be query.
    :param str result_output_file: File for saving results.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['clusterName'] = cluster_name
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tcaplus/getClusters:getClusters', __args__, opts=opts, typ=GetClustersResult).value

    return AwaitableGetClustersResult(
        cluster_id=__ret__.cluster_id,
        cluster_name=__ret__.cluster_name,
        id=__ret__.id,
        lists=__ret__.lists,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_clusters)
def get_clusters_output(cluster_id: Optional[pulumi.Input[Optional[str]]] = None,
                        cluster_name: Optional[pulumi.Input[Optional[str]]] = None,
                        result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetClustersResult]:
    """
    Use this data source to query TcaplusDB clusters.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Tcaplus.get_clusters(cluster_name="cluster")
    id = tencentcloud.Tcaplus.get_clusters(cluster_id=tencentcloud_tcaplus_cluster["test"]["id"])
    idname = tencentcloud.Tcaplus.get_clusters(cluster_id=tencentcloud_tcaplus_cluster["test"]["id"],
        cluster_name="cluster")
    ```


    :param str cluster_id: ID of the TcaplusDB cluster to be query.
    :param str cluster_name: Name of the TcaplusDB cluster to be query.
    :param str result_output_file: File for saving results.
    """
    ...
