# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRepositoriesResult',
    'AwaitableGetRepositoriesResult',
    'get_repositories',
    'get_repositories_output',
]

@pulumi.output_type
class GetRepositoriesResult:
    """
    A collection of values returned by getRepositories.
    """
    def __init__(__self__, id=None, instance_id=None, namespace_name=None, repository_lists=None, repository_name=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if namespace_name and not isinstance(namespace_name, str):
            raise TypeError("Expected argument 'namespace_name' to be a str")
        pulumi.set(__self__, "namespace_name", namespace_name)
        if repository_lists and not isinstance(repository_lists, list):
            raise TypeError("Expected argument 'repository_lists' to be a list")
        pulumi.set(__self__, "repository_lists", repository_lists)
        if repository_name and not isinstance(repository_name, str):
            raise TypeError("Expected argument 'repository_name' to be a str")
        pulumi.set(__self__, "repository_name", repository_name)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="namespaceName")
    def namespace_name(self) -> str:
        """
        Name of the namespace that the repository belongs to.
        """
        return pulumi.get(self, "namespace_name")

    @property
    @pulumi.getter(name="repositoryLists")
    def repository_lists(self) -> Sequence['outputs.GetRepositoriesRepositoryListResult']:
        """
        Information list of the dedicated TCR repositories.
        """
        return pulumi.get(self, "repository_lists")

    @property
    @pulumi.getter(name="repositoryName")
    def repository_name(self) -> Optional[str]:
        return pulumi.get(self, "repository_name")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetRepositoriesResult(GetRepositoriesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRepositoriesResult(
            id=self.id,
            instance_id=self.instance_id,
            namespace_name=self.namespace_name,
            repository_lists=self.repository_lists,
            repository_name=self.repository_name,
            result_output_file=self.result_output_file)


def get_repositories(instance_id: Optional[str] = None,
                     namespace_name: Optional[str] = None,
                     repository_name: Optional[str] = None,
                     result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRepositoriesResult:
    """
    Use this data source to query detailed information of TCR repositories.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Tcr.get_repositories(name="test")
    ```


    :param str instance_id: ID of the TCR instance that the repository belongs to.
    :param str namespace_name: Name of the namespace that the repository belongs to.
    :param str repository_name: ID of the TCR repositories to query.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['namespaceName'] = namespace_name
    __args__['repositoryName'] = repository_name
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tcr/getRepositories:getRepositories', __args__, opts=opts, typ=GetRepositoriesResult).value

    return AwaitableGetRepositoriesResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        namespace_name=__ret__.namespace_name,
        repository_lists=__ret__.repository_lists,
        repository_name=__ret__.repository_name,
        result_output_file=__ret__.result_output_file)


@_utilities.lift_output_func(get_repositories)
def get_repositories_output(instance_id: Optional[pulumi.Input[str]] = None,
                            namespace_name: Optional[pulumi.Input[str]] = None,
                            repository_name: Optional[pulumi.Input[Optional[str]]] = None,
                            result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRepositoriesResult]:
    """
    Use this data source to query detailed information of TCR repositories.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    name = tencentcloud.Tcr.get_repositories(name="test")
    ```


    :param str instance_id: ID of the TCR instance that the repository belongs to.
    :param str namespace_name: Name of the namespace that the repository belongs to.
    :param str repository_name: ID of the TCR repositories to query.
    :param str result_output_file: Used to save results.
    """
    ...
