# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSuperPlayerConfigsResult',
    'AwaitableGetSuperPlayerConfigsResult',
    'get_super_player_configs',
    'get_super_player_configs_output',
]

@pulumi.output_type
class GetSuperPlayerConfigsResult:
    """
    A collection of values returned by getSuperPlayerConfigs.
    """
    def __init__(__self__, config_lists=None, id=None, name=None, result_output_file=None, sub_app_id=None, type=None):
        if config_lists and not isinstance(config_lists, list):
            raise TypeError("Expected argument 'config_lists' to be a list")
        pulumi.set(__self__, "config_lists", config_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if sub_app_id and not isinstance(sub_app_id, int):
            raise TypeError("Expected argument 'sub_app_id' to be a int")
        pulumi.set(__self__, "sub_app_id", sub_app_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="configLists")
    def config_lists(self) -> Sequence['outputs.GetSuperPlayerConfigsConfigListResult']:
        """
        A list of super player configs. Each element contains the following attributes:
        """
        return pulumi.get(self, "config_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Display name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="subAppId")
    def sub_app_id(self) -> Optional[int]:
        return pulumi.get(self, "sub_app_id")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Template type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
        """
        return pulumi.get(self, "type")


class AwaitableGetSuperPlayerConfigsResult(GetSuperPlayerConfigsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSuperPlayerConfigsResult(
            config_lists=self.config_lists,
            id=self.id,
            name=self.name,
            result_output_file=self.result_output_file,
            sub_app_id=self.sub_app_id,
            type=self.type)


def get_super_player_configs(name: Optional[str] = None,
                             result_output_file: Optional[str] = None,
                             sub_app_id: Optional[int] = None,
                             type: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSuperPlayerConfigsResult:
    """
    Use this data source to query detailed information of VOD super player configs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_super_player_config = tencentcloud.vod.SuperPlayerConfig("fooSuperPlayerConfig",
        drm_switch=True,
        drm_streaming_info=tencentcloud.vod.SuperPlayerConfigDrmStreamingInfoArgs(
            simple_aes_definition=tencentcloud_vod_adaptive_dynamic_streaming_template["foo"]["id"],
        ),
        image_sprite_definition=tencentcloud_vod_image_sprite_template["foo"]["id"],
        resolution_names=[
            tencentcloud.vod.SuperPlayerConfigResolutionNameArgs(
                min_edge_length=889,
                name="test1",
            ),
            tencentcloud.vod.SuperPlayerConfigResolutionNameArgs(
                min_edge_length=890,
                name="test2",
            ),
        ],
        domain="Default",
        scheme="Default",
        comment="test")
    foo_super_player_configs = tencentcloud.Vod.get_super_player_configs(type="Custom",
        name="tf-super-player")
    ```


    :param str name: Name of super player config.
    :param str result_output_file: Used to save results.
    :param int sub_app_id: Subapplication ID in VOD. If you need to access a resource in a subapplication, enter the subapplication ID in this field; otherwise, leave it empty.
    :param str type: Config type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['resultOutputFile'] = result_output_file
    __args__['subAppId'] = sub_app_id
    __args__['type'] = type
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Vod/getSuperPlayerConfigs:getSuperPlayerConfigs', __args__, opts=opts, typ=GetSuperPlayerConfigsResult).value

    return AwaitableGetSuperPlayerConfigsResult(
        config_lists=__ret__.config_lists,
        id=__ret__.id,
        name=__ret__.name,
        result_output_file=__ret__.result_output_file,
        sub_app_id=__ret__.sub_app_id,
        type=__ret__.type)


@_utilities.lift_output_func(get_super_player_configs)
def get_super_player_configs_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                                    result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    sub_app_id: Optional[pulumi.Input[Optional[int]]] = None,
                                    type: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSuperPlayerConfigsResult]:
    """
    Use this data source to query detailed information of VOD super player configs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_super_player_config = tencentcloud.vod.SuperPlayerConfig("fooSuperPlayerConfig",
        drm_switch=True,
        drm_streaming_info=tencentcloud.vod.SuperPlayerConfigDrmStreamingInfoArgs(
            simple_aes_definition=tencentcloud_vod_adaptive_dynamic_streaming_template["foo"]["id"],
        ),
        image_sprite_definition=tencentcloud_vod_image_sprite_template["foo"]["id"],
        resolution_names=[
            tencentcloud.vod.SuperPlayerConfigResolutionNameArgs(
                min_edge_length=889,
                name="test1",
            ),
            tencentcloud.vod.SuperPlayerConfigResolutionNameArgs(
                min_edge_length=890,
                name="test2",
            ),
        ],
        domain="Default",
        scheme="Default",
        comment="test")
    foo_super_player_configs = tencentcloud.Vod.get_super_player_configs(type="Custom",
        name="tf-super-player")
    ```


    :param str name: Name of super player config.
    :param str result_output_file: Used to save results.
    :param int sub_app_id: Subapplication ID in VOD. If you need to access a resource in a subapplication, enter the subapplication ID in this field; otherwise, leave it empty.
    :param str type: Config type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
    """
    ...
