# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SslClientArgs', 'SslClient']

@pulumi.input_type
class SslClientArgs:
    def __init__(__self__, *,
                 ssl_vpn_client_name: pulumi.Input[str],
                 ssl_vpn_server_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a SslClient resource.
        :param pulumi.Input[str] ssl_vpn_client_name: The name of ssl vpn client to be created.
        :param pulumi.Input[str] ssl_vpn_server_id: VPN ssl server id.
        """
        pulumi.set(__self__, "ssl_vpn_client_name", ssl_vpn_client_name)
        pulumi.set(__self__, "ssl_vpn_server_id", ssl_vpn_server_id)

    @property
    @pulumi.getter(name="sslVpnClientName")
    def ssl_vpn_client_name(self) -> pulumi.Input[str]:
        """
        The name of ssl vpn client to be created.
        """
        return pulumi.get(self, "ssl_vpn_client_name")

    @ssl_vpn_client_name.setter
    def ssl_vpn_client_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "ssl_vpn_client_name", value)

    @property
    @pulumi.getter(name="sslVpnServerId")
    def ssl_vpn_server_id(self) -> pulumi.Input[str]:
        """
        VPN ssl server id.
        """
        return pulumi.get(self, "ssl_vpn_server_id")

    @ssl_vpn_server_id.setter
    def ssl_vpn_server_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "ssl_vpn_server_id", value)


@pulumi.input_type
class _SslClientState:
    def __init__(__self__, *,
                 ssl_vpn_client_name: Optional[pulumi.Input[str]] = None,
                 ssl_vpn_server_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SslClient resources.
        :param pulumi.Input[str] ssl_vpn_client_name: The name of ssl vpn client to be created.
        :param pulumi.Input[str] ssl_vpn_server_id: VPN ssl server id.
        """
        if ssl_vpn_client_name is not None:
            pulumi.set(__self__, "ssl_vpn_client_name", ssl_vpn_client_name)
        if ssl_vpn_server_id is not None:
            pulumi.set(__self__, "ssl_vpn_server_id", ssl_vpn_server_id)

    @property
    @pulumi.getter(name="sslVpnClientName")
    def ssl_vpn_client_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of ssl vpn client to be created.
        """
        return pulumi.get(self, "ssl_vpn_client_name")

    @ssl_vpn_client_name.setter
    def ssl_vpn_client_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_vpn_client_name", value)

    @property
    @pulumi.getter(name="sslVpnServerId")
    def ssl_vpn_server_id(self) -> Optional[pulumi.Input[str]]:
        """
        VPN ssl server id.
        """
        return pulumi.get(self, "ssl_vpn_server_id")

    @ssl_vpn_server_id.setter
    def ssl_vpn_server_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_vpn_server_id", value)


class SslClient(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ssl_vpn_client_name: Optional[pulumi.Input[str]] = None,
                 ssl_vpn_server_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provide a resource to create a VPN SSL Client.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        client = tencentcloud.vpn.SslClient("client",
            ssl_vpn_client_name="hello",
            ssl_vpn_server_id="vpns-aog5xcjj")
        ```

        ## Import

        VPN SSL Client can be imported, e.g.

        ```sh
         $ pulumi import tencentcloud:Vpn/sslClient:SslClient client vpn-client-id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ssl_vpn_client_name: The name of ssl vpn client to be created.
        :param pulumi.Input[str] ssl_vpn_server_id: VPN ssl server id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SslClientArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provide a resource to create a VPN SSL Client.

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        client = tencentcloud.vpn.SslClient("client",
            ssl_vpn_client_name="hello",
            ssl_vpn_server_id="vpns-aog5xcjj")
        ```

        ## Import

        VPN SSL Client can be imported, e.g.

        ```sh
         $ pulumi import tencentcloud:Vpn/sslClient:SslClient client vpn-client-id
        ```

        :param str resource_name: The name of the resource.
        :param SslClientArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SslClientArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ssl_vpn_client_name: Optional[pulumi.Input[str]] = None,
                 ssl_vpn_server_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SslClientArgs.__new__(SslClientArgs)

            if ssl_vpn_client_name is None and not opts.urn:
                raise TypeError("Missing required property 'ssl_vpn_client_name'")
            __props__.__dict__["ssl_vpn_client_name"] = ssl_vpn_client_name
            if ssl_vpn_server_id is None and not opts.urn:
                raise TypeError("Missing required property 'ssl_vpn_server_id'")
            __props__.__dict__["ssl_vpn_server_id"] = ssl_vpn_server_id
        super(SslClient, __self__).__init__(
            'tencentcloud:Vpn/sslClient:SslClient',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ssl_vpn_client_name: Optional[pulumi.Input[str]] = None,
            ssl_vpn_server_id: Optional[pulumi.Input[str]] = None) -> 'SslClient':
        """
        Get an existing SslClient resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ssl_vpn_client_name: The name of ssl vpn client to be created.
        :param pulumi.Input[str] ssl_vpn_server_id: VPN ssl server id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SslClientState.__new__(_SslClientState)

        __props__.__dict__["ssl_vpn_client_name"] = ssl_vpn_client_name
        __props__.__dict__["ssl_vpn_server_id"] = ssl_vpn_server_id
        return SslClient(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="sslVpnClientName")
    def ssl_vpn_client_name(self) -> pulumi.Output[str]:
        """
        The name of ssl vpn client to be created.
        """
        return pulumi.get(self, "ssl_vpn_client_name")

    @property
    @pulumi.getter(name="sslVpnServerId")
    def ssl_vpn_server_id(self) -> pulumi.Output[str]:
        """
        VPN ssl server id.
        """
        return pulumi.get(self, "ssl_vpn_server_id")

